/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */
import java.io.IOException;
import net.tinyos.message.*;
import java.util.Vector;
public class Communication{
//	----------------- Sending PC to mote instruction ------------------------//   
	 public void sendPackets(MoteIF to,short type,short lastseqn, short nd1, short nd2,short payload_sz, short ipt, short txpower, short channel, short max_retries, short totalpkt) {
		CommandMsg payload = new CommandMsg();
	    try {
	    // type of messages:1- receiving packet 2- finish task reporting 3- sender feedback 4- reply to "finish task" suggest
	    payload.set_type(type);
		payload.set_node1(nd1);
		payload.set_node2(nd2);
		payload.set_payload_sz(payload_sz);
		payload.set_lastseqn(lastseqn);
	    payload.set_ipi(ipt);
		payload.set_txpower(txpower);
		payload.set_channel(channel);
		payload.set_max_retries(max_retries);
		payload.set_totalpacket(totalpkt);
		to.send(0, payload);
	    }
	    catch (IOException exception) {
	      System.err.println("Exception thrown when sending packets. Exit!");
	      System.err.println(exception);
	    }
	  }
}
