/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */
import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.JRadioButton;
import javax.swing.JToggleButton;
import javax.swing.ListSelectionModel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableModel;
import java.sql.ResultSet;
import java.text.DecimalFormat;
import javax.swing.JList;
import java.util.ArrayList;
import java.util.List;
import java.awt.BorderLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JScrollPane;
import javax.swing.ImageIcon;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JOptionPane;
import javax.swing.JFrame;
import java.awt.Font;
import java.awt.Rectangle;
import javax.swing.BorderFactory;
import java.awt.Color;

public class Database_Query extends JPanel{
	LocationFrame location;
	private JPanel getdata = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JComboBox comboExpId = null;
	private JComboBox comboExpRunNbr = null;
	private JComboBox sender = null;
	private JComboBox receiver = null;
	private JButton Import = null;
	private JButton delbutton = null;
	private JList optionImport = null;
	private JButton graph = null;
	private JPanel jPanel = null;
	private JScrollPane ScrollList = null;
	private JPanel panelDataFromDB = null;
	private JTable tableExp = null;
	private JTextArea commentdb = null;
	private JTable tabledb = null;
	private JScrollPane jScrollPane1 = null;
	private JScrollPane jScrollPane2 = null;
	private JLabel jLabel4 = null;
	private JRadioButton jRadioButton = null;
	private JRadioButton jRadioButton1 = null;
	private ButtonGroup buttonGroup = null; 
	static DefaultListModel listModel = new DefaultListModel();
	private JLabel jLabel41 = null;
	private	DefaultListModel defaultmodel = new DefaultListModel();
	private DBconnection db = new DBconnection();

	public Database_Query() {
		super();
		initialize();
	}

	private void initialize() {
        this.setSize(new java.awt.Dimension(1200,693));
        this.setLayout(null);
		try{ 
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
		}catch(Exception e){
			e.printStackTrace();	
		} 
		SwingUtilities.updateComponentTreeUI(this);
        this.setBackground(java.awt.SystemColor.control);
        this.setFont(new java.awt.Font("Arial",0,12));
        this.setPreferredSize(new java.awt.Dimension(1200, 224));
        this.add(getGetdata(), null);
        this.add(getJPanel(), null);
        this.add(getPanelDataFromDB(), null);
        initTabledb();
        initTableExp();
	}

	public void tabbedPaneFocusGained() { 
	    getImport().setEnabled(false);
	    getDelButton().setEnabled(false);
	    getGraph().setEnabled(false);
	    getComboExpId().setEnabled(false);
	    getComboExpRunNbr().setEnabled(false);
	    getReceiver().setEnabled(false);
	    getSender().setEnabled(false);
	    getOptionImport(false).setEnabled(false);
	    jRadioButton.setEnabled(false);
	    jRadioButton1.setEnabled(false);
	    jRadioButton.setSelected(false);
	    jRadioButton1.setSelected(false);
	    getGraph().setEnabled(false);
	    listModel.removeAllElements();
	    getComboExpId().removeAllItems();
	    db.open_a_connection();
	    getComboExpId().addItem("");
	    ResultSet result = db.select("SELECT DISTINCT exp_id FROM experiment order by rownum DESC ;");
	    try {
	    	    while (result.next()) {
	        	getComboExpId().addItem(result.getString(1));
	        }
	        getComboExpId().setEnabled(true);
	    } catch (Exception e) {e.printStackTrace();}
	}

	private JPanel getGetdata() {
		if (getdata == null) {
			jLabel41 = new JLabel();
			jLabel41.setBounds(new Rectangle(336, 42, 115, 15));
			jLabel41.setForeground(new Color(153, 153, 153));
			jLabel41.setText("<html>5. Select the type </html>");
			jLabel41.setFont(new Font("Arial", Font.BOLD, 12));
			jLabel4 = new JLabel();
			jLabel4.setBounds(new java.awt.Rectangle(335,75,273,30));
			jLabel4.setText("<html>6. Select an item to generate the corresponding graph</html>");
			jLabel4.setForeground(new java.awt.Color(153,153,153));
			jLabel4.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jLabel3 = new JLabel();
			jLabel3.setText("4. Select a receiver ID");
			jLabel3.setForeground(new java.awt.Color(153,153,153));
			jLabel3.setBounds(new java.awt.Rectangle(9,145,141,24));
			jLabel3.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jLabel2 = new JLabel();
			jLabel2.setText("3. Select a sender ID");
			jLabel2.setForeground(new java.awt.Color(153,153,153));
			jLabel2.setBounds(new java.awt.Rectangle(10,110,139,23));
			jLabel2.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jLabel1 = new JLabel();
			jLabel1.setText("2. Select a run number");
			jLabel1.setForeground(new java.awt.Color(153,153,153));
			jLabel1.setSize(new java.awt.Dimension(153,22));
			jLabel1.setLocation(new java.awt.Point(9,75));
			jLabel1.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jLabel = new JLabel();
			jLabel.setText("1. Select an experiment ID");
			jLabel.setForeground(new java.awt.Color(153,153,153));
			jLabel.setBounds(new java.awt.Rectangle(8,40,165,22));
			jLabel.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			getdata = new JPanel();
			getdata.setLayout(null);
			getdata.add(getComboExpId(), null);
			getdata.add(getImport(), null);
			getdata.add(jLabel4, null);
			getdata.add(getSender(), null);
			getdata.add(getReceiver(), null);
			getdata.add(getComboExpRunNbr(), null);
			getdata.setBounds(new java.awt.Rectangle(12,11,625,220));
			getdata.setBackground(java.awt.SystemColor.control);
			getdata.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Load Experiment data", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.BOLD, 12), new java.awt.Color(51,51,51)));
			getdata.add(jLabel, null);
			getdata.add(jLabel1, null);
			getdata.add(jLabel2, null);
			getdata.add(jLabel3, null);
			getdata.add(getJRadioButton(), null);
			getdata.add(getJRadioButton1(), null);
			getdata.add(getOptionImport(false), null);
			getdata.add(getGraph(), null);
			getdata.add(getDelButton(), null); 
			getdata.add(getScrollList(), null);
			getdata.add(jLabel41, null);
		}
		return getdata;
	}

	private JComboBox getComboExpId() {
		if (comboExpId == null) {
			comboExpId = new JComboBox();
			comboExpId.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			comboExpId.setBounds(new java.awt.Rectangle(182,40,138,25));
			comboExpId.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					 comboExpIdItemStateChanged(e);
				}
			});
		}
		return comboExpId;
	}

	private void comboExpIdItemStateChanged(java.awt.event.ItemEvent evt) {                                            
	    String sql = null;
	    if (comboExpId.getSelectedIndex() >0){
	    	getComboExpRunNbr().removeAllItems();
	    	getComboExpRunNbr().addItem("");
	    	getComboExpRunNbr().setEnabled(true);
		sql = "SELECT DISTINCT exp_run_nbr FROM experiment Where exp_id = '" + comboExpId.getSelectedItem() + "';";
	        ResultSet result = db.select(sql);
	        try {
	            while (result.next()) {
	                getComboExpRunNbr().addItem(""+result.getInt(1));
	            }
	        } catch (Exception e) {
	            e.printStackTrace();
	        }
		getDelButton().setEnabled(false);
	    }
	}

	private JComboBox getComboExpRunNbr() {
		if (comboExpRunNbr == null) {
			comboExpRunNbr = new JComboBox();
			comboExpRunNbr.setBounds(new java.awt.Rectangle(182,75,138,25));
			comboExpRunNbr.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			comboExpRunNbr.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					comboExpRunNbrItemStateChanged(e);
				}
			});
		}
		return comboExpRunNbr;
	}

	private void comboExpRunNbrItemStateChanged(java.awt.event.ItemEvent evt) {                                                
	    String sql = null;
	    if (comboExpRunNbr.getSelectedIndex() > 0 && comboExpId.getSelectedIndex() > 0){
	    	getSender().removeAllItems();
	    	getSender().addItem("");
	    	getSender().addItem("All");
		sql = "SELECT DISTINCT src_id FROM SenderSide WHERE exp_id = '" + getComboExpId().getSelectedItem() + "' and " +
	                " exp_run_nbr = '" + comboExpRunNbr.getSelectedItem() + "';";
	        ResultSet result = db.select(sql);
	        try {
	            while (result.next()) {
	            	getSender().addItem(""+result.getInt(1));
	            }
	        } catch (Exception e) {
	            e.printStackTrace();
	        }
	        sender.setEnabled(true);
		getDelButton().setEnabled(true);
	    }
	} 

	private JComboBox getSender() {
		if (sender == null) {
			sender = new JComboBox();
			sender.setBounds(new java.awt.Rectangle(182,110,138,25));
			sender.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
	        	sender.addItemListener(new java.awt.event.ItemListener() {
	            public void itemStateChanged(java.awt.event.ItemEvent evt) {
	                senderItemStateChanged(evt);
	            }
	        });
		}
		return sender;
	}

	private void senderItemStateChanged(java.awt.event.ItemEvent evt) {                                        
	    String sql = null;
	    if (sender.getSelectedIndex() > 0){
	    	getReceiver().removeAllItems();
	    	getReceiver().addItem("");
	    	getReceiver().addItem("All");
	        sql = "SELECT DISTINCT rcv_id FROM SenderSide ";
	        if (sender.getSelectedIndex() == 1)
	            sql += "WHERE exp_id = '" + getComboExpId().getSelectedItem() + "' and exp_run_nbr = '" 
	                    + getComboExpRunNbr().getSelectedItem() + "';";
	        else if (sender.getSelectedIndex() > 1)
	            sql += "WHERE src_id = " + sender.getSelectedItem() + " and exp_id = '" + getComboExpId().getSelectedItem() + 
	                "' and exp_run_nbr = '" + getComboExpRunNbr().getSelectedItem() + "';";
	        ResultSet result = db.select(sql);
	        try {
	           while (result.next()) {
	                receiver.addItem(""+result.getInt(1));
	            }
	        } catch (Exception e) {
	            e.printStackTrace();
	        }
	        receiver.setEnabled(true);
	    }
	} 

	private JComboBox getReceiver() {
		if (receiver == null) {
			receiver = new JComboBox();
			receiver.setBounds(new java.awt.Rectangle(182,145,138,25));
			receiver.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			receiver.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					receiverItemStateChanged(e);
				}
			});
		}
		return receiver;
	}

	private void receiverItemStateChanged(java.awt.event.ItemEvent evt) {                                          
	    if (receiver.getSelectedIndex() > 0){
	        getImport().setEnabled(true);
	        jRadioButton.setEnabled(true);
	        jRadioButton1.setEnabled(true);
	    }
	}  

	private JButton getImport() {
		if (Import == null) {
			Import = new JButton();
			Import.setToolTipText("Click to import data \n from the database");
			Import.setBounds(new java.awt.Rectangle(182,180,128,22));
			Import.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
			Import.setIcon(new ImageIcon(getClass().getResource("images/import.png")));
			Import.setText("Import data");
			Import.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					ImportActionPerformed(e);
				}
			});
		}
		return Import;
	}

	private void ImportActionPerformed(java.awt.event.ActionEvent evt) {                                       
	    String error = "";
	    if (getSender().getSelectedIndex()==0)
	        error += "You need select one especific or all sender\n";
	    if (getReceiver().getSelectedIndex()==0)
	        error += "You need select one especific or all receiver\n";
	    if (getComboExpId().getSelectedIndex()==0)
	        error += "You need select one especific experience id\n";
	    if (getComboExpRunNbr().getSelectedIndex()==0)
	        error += "You need select one especific experience run number";
	    if (!error.equals(""))
	        JOptionPane.showMessageDialog(null,error, "Link Quality Estimation and Characterization", JOptionPane.ERROR_MESSAGE);
	    else
	        selectData ();
	}   
	
    private void selectData(){
        DefaultTableModel dtm = (DefaultTableModel)getTabledb().getModel();
        for (int i = getTabledb().getRowCount() - 1; i >= 0; i--)
            dtm.removeRow(i);
        selectExperiment();
        String sql = "SELECT src_id, seq_no, exp_id, exp_run_nbr, src_x, src_y, src_z, " +
               "src_timestamp, rcv_id, rcv_x, rcv_y, rcv_z, rcv_timestamp, rtxcount, lqi, rssi, noise, snr, humidity, " +
               "temperature, voltage, light1,light2, pressure FROM linkData WHERE exp_id = '" + 
               getComboExpId().getSelectedItem() + "' and exp_run_nbr = '" + getComboExpRunNbr().getSelectedItem() + "'";
        if (getSender().getSelectedIndex()>1)
            sql += " and src_id = " + getSender().getSelectedItem();
        if (getReceiver().getSelectedIndex()>1)
            sql += " and rcv_id = " + getReceiver().getSelectedItem();
        sql += ";";
        ResultSet result = db.select(sql);
        try {
           while (result.next()) {
               setTabledb( result.getInt(2), result.getInt(1), result.getInt(9), result.getInt(15), 
                        result.getInt(16), result.getInt(17), result.getFloat(18), result.getString(8), result.getString(13),
                        result.getDouble(19), result.getDouble(20), result.getFloat(21), result.getString(5),
                        result.getString(6), result.getString(7), result.getString(10), result.getString(11), 
                        result.getString(12), result.getFloat(22), result.getFloat(23), result.getDouble(24));               
           }
        } catch (Exception e) {e.printStackTrace();}
    }

	private JList getOptionImport(boolean status) {
		if (optionImport == null) {
			optionImport = new JList(defaultmodel);
			optionImport.setLayoutOrientation(JList.VERTICAL);
			optionImport.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
			optionImport.setFont(new java.awt.Font("Arial", 0, 10));
			optionImport.setEnabled(false);
		}
		else if (status){
			defaultmodel.removeAllElements();
			if (jRadioButton.isSelected()){
				defaultmodel.addElement("PACKET RECEPTION RATE");
				defaultmodel.addElement("PACKET RECEPTION RATE - BAR");
				defaultmodel.addElement("REGION OF MOTES");
			}
			defaultmodel.addElement("LQI");
			defaultmodel.addElement("RSSI");
			defaultmodel.addElement("NOISE");
			defaultmodel.addElement("SNR");
			defaultmodel.addElement("HUMIDITY");
			defaultmodel.addElement("TEMPERATURE");
			defaultmodel.addElement("LIGHT1");
			defaultmodel.addElement("LIGHT2");
			defaultmodel.addElement("VOLTAGE");
			defaultmodel.addElement("LOCATION");
		}
		return optionImport;
	}

	private JButton getGraph() {
		if (graph == null) {
			graph = new JButton();
			graph.setBounds(new java.awt.Rectangle(445,180,160,22));
			graph.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
			graph.setText("Generate graph");
			graph.setIcon(new ImageIcon(getClass().getResource("images/chart.png")));
			graph.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					graphActionPerformed(e);
				}
			});
		}
		return graph;
	}

	private void graphActionPerformed(java.awt.event.ActionEvent evt) {                                      
	    String error = "", sql = "";
	    if (getSender().getSelectedIndex()==0)
	        error += "You need to select one especific or all sender\n";
	    if (getReceiver().getSelectedIndex()==0)
	        error += "You need to select one especific or all receiver\n";
	    if (getComboExpId().getSelectedIndex()==0)
	        error += "You need to select one especific experience id\n";
	    if (getComboExpRunNbr().getSelectedIndex()==0)
	        error += "You need select one especific experience run number";
	    if (!error.equals(""))
	    	JOptionPane.showMessageDialog(null,error,"ERROR",JOptionPane.ERROR_MESSAGE);
	    else{
		Object[] tab1 = getOptionImport(false).getSelectedValues();
		for (int o = 0; o < tab1.length; o++){
			if (searching(listModel,tab1[o]))
				listModel.addElement(tab1[o]);
		}
		List<String>  idSender = new ArrayList<String>();
		List<String>  idReceiver = new ArrayList<String>();
		if (listModel.size()>0){
			selectExperiment();
	        	if (sender.getSelectedIndex()==1){
	        	    sql = "SELECT DISTINCT src_id FROM SenderSide WHERE exp_id = '" + getComboExpId().getSelectedItem() + 
	        	        "' and exp_run_nbr = '" + getComboExpRunNbr().getSelectedItem() + "'";
	        	    ResultSet result = db.select(sql);
	        	    try {
	        	        while (result.next()) {
	        	            idSender.add(result.getString(1));
				    //System.out.println("sender "+result.getString(1));
	        	        }
	        	    } catch (Exception e) {e.printStackTrace();}
	        	}
	        	else
	        	    idSender.add(""+getSender().getSelectedItem()+"");
	        	
	        	if (getReceiver().getSelectedIndex()==1){
	        	    sql = "SELECT DISTINCT rcv_id FROM SenderSide WHERE exp_id = '" + getComboExpId().getSelectedItem() + 
	        	        "' and exp_run_nbr = '" + getComboExpRunNbr().getSelectedItem() + "'";
	        	    if (sender.getSelectedIndex()>1)
	        	        sql += " and src_id = " +getSender().getSelectedItem();
	        	    sql += ";";
	        	    ResultSet result = db.select(sql);
	        	    try {
	        	        while (result.next()) {
	        	            idReceiver.add(result.getString(1));
	        	        }
	        	    } catch (Exception e) {e.printStackTrace();}
	        	}
	        	else
	        	    idReceiver.add(""+getReceiver().getSelectedItem()+"");
		}
		if (listModel.size()>0 && jRadioButton.isSelected()){
	        	Object[] tab = getOptionImport(false).getSelectedValues();
	        	for (int o = 0; o < tab.length; o++){
	        		if (tab[o].equals("LOCATION")){
					if (location != null)
		        			location.setVisible(false);
		        		location = new LocationFrame(getComboExpId().getSelectedItem().toString(), getComboExpRunNbr().getSelectedItem().toString(), idSender, idReceiver);
		        		location.setVisible(true);DefaultListModel defaultmodel = new DefaultListModel();
					optionImport = new JList(defaultmodel);
				}
				else if (tab[o].equals("PACKET RECEPTION RATE")){
					JFrame frame = new JFrame("LQC&E_TB - Graph");
				        GraphPRR demo = new GraphPRR(getComboExpId().getSelectedItem().toString(), getComboExpRunNbr().getSelectedItem().toString(), idSender, idReceiver);
					frame.getContentPane().add(demo, BorderLayout.CENTER);
					frame.setBounds(10, 10, 1250, 750);
					frame.setVisible(true);
				        frame.addWindowListener(new WindowAdapter() {
						public void demoClosing(WindowEvent e) {
	        					System.exit(0);
			        		}
					});
				}
	        		else if (tab[o].equals("REGION OF MOTES")){
					JFrame frame = new JFrame("LQC&E_TB - Graph");
				        GraphRegion demo = new GraphRegion(getComboExpId().getSelectedItem().toString(), getComboExpRunNbr().getSelectedItem().toString(), idSender, idReceiver);
					frame.getContentPane().add(demo, BorderLayout.CENTER);
					frame.setBounds(10, 10, 1250, 750);
					frame.setVisible(true);
				        frame.addWindowListener(new WindowAdapter() {
						public void demoClosing(WindowEvent e) {
	        					System.exit(0);
			        		}
					});
				}
				else if (tab[o].equals("PACKET RECEPTION RATE - BAR")){
					JFrame frame = new JFrame("LQC&E_TB - Graph");
					GraphPRRBar demo = new GraphPRRBar(getComboExpId().getSelectedItem().toString(), getComboExpRunNbr().getSelectedItem().toString(), idSender, idReceiver);
		        		frame.getContentPane().add(demo, BorderLayout.CENTER);
		        		frame.setBounds(10, 10, 1250, 750);
		        		frame.setVisible(true);
		        		frame.addWindowListener(new WindowAdapter() {
		        			public void demoClosing(WindowEvent e) {
						        System.exit(0);
					        }
		        		});
				}
	        		else{
					JFrame frame = new JFrame("LQC&E_TB - Graph");
					Graph demo = new Graph(getComboExpId().getSelectedItem().toString(), getComboExpRunNbr().getSelectedItem().toString(), idSender, idReceiver, tab[o].toString());
		        		frame.getContentPane().add(demo, BorderLayout.CENTER);
		        		frame.setBounds(10, 10, 1250, 750);
		        		frame.setVisible(true);
		        		frame.addWindowListener(new WindowAdapter() {
		        			public void demoClosing(WindowEvent e) {
						        System.exit(0);
					        }
		        		});
				}
			}
	    	}
	    	if (listModel.size()>0 && jRadioButton1.isSelected()){
        		Object[] tab = getOptionImport(false).getSelectedValues();
        		boolean var = false;
        		List<String>  reading = new ArrayList<String>();

			for (int o = 0; o < tab.length; o++){
				if (tab[o].equals("LOCATION")){
		        		if (location != null)
		        			location.setVisible(false);
		        		location = new LocationFrame(getComboExpId().getSelectedItem().toString(), getComboExpRunNbr().getSelectedItem().toString(), idSender, idReceiver);
		        		location.setVisible(true);
				}
				else {
		        		JFrame frame = new JFrame("RadiaLE - Graph");
					GraphTimeLine demo = new GraphTimeLine(getComboExpId().getSelectedItem().toString(), getComboExpRunNbr().getSelectedItem().toString(), idSender, idReceiver, tab[o].toString());
		        		frame.getContentPane().add(demo, BorderLayout.CENTER);
		        		frame.setBounds(120, 120, 1000, 600);
		        		frame.setVisible(true);
		        		frame.addWindowListener(new WindowAdapter() {
		        			public void demoClosing(WindowEvent e) {
						        System.exit(0);
					        }
		        		});
				}
			}
	    	}
	    }
	}
	
	
	private void selectExperiment(){
        String sql = "SELECT exp_date, exp_time, exp_payload_size, exp_inter_pkt_time, exp_nbr_sent_packet, " +
              "exp_nbr_nodes, exp_tx_power, exp_channel, exp_ack_onoff, exp_max_retries, exp_topology, " +
              "exp_node_type, exp_country, exp_city, exp_description, exp_traffic FROM experiment WHERE exp_id = '" +
              getComboExpId().getSelectedItem() + "' and exp_run_nbr = '" + getComboExpRunNbr().getSelectedItem() + "';";
       ResultSet result = db.select(sql);
       DefaultTableModel dtm = (DefaultTableModel)tableExp.getModel();
       for (int i = getTableExp().getRowCount() - 1; i >= 0; i--)
           dtm.removeRow(i);
       try {
           while (result.next()) {
               int i = 0;
               dtm.insertRow(i++, new Object[]{"Exp id", getComboExpId().getSelectedItem()});
               dtm.insertRow(i++, new Object[]{"Exp run nbr ", getComboExpRunNbr().getSelectedItem()});
               dtm.insertRow(i++, new Object[]{"Date", result.getString(1)});
               dtm.insertRow(i++, new Object[]{"Time", result.getString(2)});
               dtm.insertRow(i++, new Object[]{"Payload size", result.getString(3)});
               dtm.insertRow(i++, new Object[]{"Inter pkt time", result.getString(4)});
               dtm.insertRow(i++, new Object[]{"Nbr sent pkt", result.getString(5)});
               dtm.insertRow(i++, new Object[]{"Nbr nodes", result.getString(6)});
               dtm.insertRow(i++, new Object[]{"Trans power", result.getString(7)});
               dtm.insertRow(i++, new Object[]{"Channel", result.getString(8)});
               dtm.insertRow(i++, new Object[]{"Ack on/off", result.getBoolean(9)});
               dtm.insertRow(i++, new Object[]{"Max ret", result.getString(10)});
               dtm.insertRow(i++, new Object[]{"Topology", result.getString(11)});
               dtm.insertRow(i++, new Object[]{"Node Type", result.getString(12)});
               dtm.insertRow(i++, new Object[]{"Country", result.getString(13)});
               dtm.insertRow(i++, new Object[]{"City", result.getString(14)});
               dtm.insertRow(i++, new Object[]{"Traffic", result.getString(16)});
               getCommentdb().setText(result.getString(15));
           }
       } catch (Exception e) {e.printStackTrace();}
    }

	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jPanel.add(getCommentdb(), null);
			jPanel.setBounds(new java.awt.Rectangle(644,12,551,220));
			jPanel.setBackground(java.awt.SystemColor.control);
			jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Experiment related info", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.BOLD, 12), new java.awt.Color(51,51,51)));
			jPanel.add(getJScrollPane1(), null);
			
			
		}
		return jPanel;
	}

	private JScrollPane getScrollList() {
		if (ScrollList == null) {
			ScrollList = new JScrollPane();
			getOptionImport(false).setEnabled(false);
			ScrollList.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			ScrollList.setBounds(new Rectangle(335, 110, 273, 60));
		}
		return ScrollList;
	}

	private JPanel getPanelDataFromDB() {
		if (panelDataFromDB == null) {
			panelDataFromDB = new JPanel();
			panelDataFromDB.setBounds(new java.awt.Rectangle(13,245,1184,422));
			panelDataFromDB.setBackground(java.awt.SystemColor.control);
			panelDataFromDB.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Received Messages", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.BOLD, 12), new java.awt.Color(51,51,51)));
			panelDataFromDB.add(getTabledb(), null);
			panelDataFromDB.add(getJScrollPane2(), null);
			panelDataFromDB.setLayout(null);
		}
		return panelDataFromDB;
	}

	private JTable getTableExp() {
		if (tableExp == null) {
			tableExp = new JTable();
			tableExp.setBounds(new java.awt.Rectangle(14,23,257,165));
		        tableExp.setFont(new java.awt.Font("Arial", 0, 14));
		        tableExp.setModel(new javax.swing.table.DefaultTableModel(new Object [][] {}, new String [] {"Property", "value"}){
			Class[] types = new Class [] {java.lang.String.class, java.lang.String.class };
			boolean[] canEdit = new boolean [] {
		       	false, false
		    };
           	public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
			public boolean isCellEditable(int rowIndex, int columnIndex) {
	        	return canEdit [columnIndex];
		    }
	        });
	        tableExp.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
		}
		return tableExp;
	}

	private JTextArea getCommentdb() {
		if (commentdb == null) {
			commentdb = new JTextArea();
			commentdb.setBounds(new java.awt.Rectangle(280,18,262,181));
			commentdb.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Comments", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			commentdb.setEnabled(false);
		}
		return commentdb;
	}

	private JTable getTabledb() {
		if (tabledb == null) {
			tabledb = new JTable();
	        tabledb.setModel(new javax.swing.table.DefaultTableModel(
	                new Object [][] {
	                },
	                new String [] {
	                    "Seq Number", "Sender", "Receiver", "LQI", "RSSI", "NRSSI", "SNR", "Src TimeStamp", "Rcv TimeStamp", "Rtx", "Humidity", "Temperature", "Voltage", "Light1", "Light2", "Sx", "Sy", "Sz", "Dx", "Dy", "Dz"
	                }
	            ) {
	                Class[] types = new Class [] {
	                    java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
	                };
	                boolean[] canEdit = new boolean [] {
	        		       	false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false
	        		};
	                public Class getColumnClass(int columnIndex) {
	                    return types [columnIndex];
	                }
	                public boolean isCellEditable(int rowIndex, int columnIndex) {
	    	        	return canEdit [columnIndex];
	    		    }
	            }	        
);
	            tabledb.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
		}
		return tabledb;
	}
  
    private void initTabledb(){
    	getTabledb().getColumnModel().getColumn(0).setPreferredWidth(85);//seq number
    	getTabledb().getColumnModel().getColumn(1).setPreferredWidth(60);//sender
    	getTabledb().getColumnModel().getColumn(2).setPreferredWidth(60);//receiver
    	getTabledb().getColumnModel().getColumn(3).setPreferredWidth(65);//lqi
    	getTabledb().getColumnModel().getColumn(4).setPreferredWidth(55);//rssi
    	getTabledb().getColumnModel().getColumn(5).setPreferredWidth(55);//nrssi
    	getTabledb().getColumnModel().getColumn(6).setPreferredWidth(60);//snr
    	getTabledb().getColumnModel().getColumn(7).setPreferredWidth(95);//src time stamp
    	getTabledb().getColumnModel().getColumn(8).setPreferredWidth(95);//rcv time stamp
    	getTabledb().getColumnModel().getColumn(9).setPreferredWidth(55);//rtx
    	getTabledb().getColumnModel().getColumn(10).setPreferredWidth(70);//humidity
    	getTabledb().getColumnModel().getColumn(11).setPreferredWidth(90);//temperature
    	getTabledb().getColumnModel().getColumn(12).setPreferredWidth(60);//voltage
    	getTabledb().getColumnModel().getColumn(13).setPreferredWidth(90);//Light
    	getTabledb().getColumnModel().getColumn(14).setPreferredWidth(90);//Light
    	getTabledb().getColumnModel().getColumn(15).setPreferredWidth(55);//src x
    	getTabledb().getColumnModel().getColumn(16).setPreferredWidth(55);//src y
    	getTabledb().getColumnModel().getColumn(17).setPreferredWidth(55);//src z
    	getTabledb().getColumnModel().getColumn(18).setPreferredWidth(55);//rcv x
    	getTabledb().getColumnModel().getColumn(19).setPreferredWidth(55);//rcv y
    	getTabledb().getColumnModel().getColumn(20).setPreferredWidth(55);//rcv z
    }
    
    private void initTableExp(){
    	tableExp.getColumnModel().getColumn(0).setPreferredWidth(110);
            tableExp.getColumnModel().getColumn(1).setPreferredWidth(130);
        }
    
    public void setTabledb( int seqNumber, int idSender, int receiver, int lqi, int rssi, int nrssi, float snr, String src_ts, String rcv_ts, double hum, double temperature, float voltage, String src_x, String src_y, String src_z, String rcv_x, String rcv_y, String rcv_z, float light1, float light2, double rtx){
        DecimalFormat df = new DecimalFormat("0.00");
        DecimalFormat df2 = new DecimalFormat("0.000");
        DefaultTableModel dtm = (DefaultTableModel)getTabledb().getModel();
	dtm.insertRow(0, new Object[]{seqNumber, idSender, receiver, lqi, rssi, nrssi, snr, src_ts, rcv_ts, rtx,
        df.format(hum), temperature, df2.format(voltage), df.format(light1), df.format(light2), src_x, src_y, src_z, rcv_x, rcv_y, rcv_z});
    }

	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setBounds(new java.awt.Rectangle(11,18,259,180));
			jScrollPane1.setViewportView(getTableExp());
			
		}
		return jScrollPane1;
	}                                      

	private JScrollPane getJScrollPane2() {
		if (jScrollPane2 == null) {
			jScrollPane2 = new JScrollPane();
			jScrollPane2.setViewportView(getTabledb());
			jScrollPane2.setBounds(new java.awt.Rectangle(15,25,1155,385));
		}
		return jScrollPane2;
	} 
	
	boolean searching(DefaultListModel mdl, Object obj)
	{
		boolean notfind=true;
		int i=0;
		while(notfind && (i<mdl.size())){
			//System.out.println("mdl"+mdl.elementAt(i));
			//System.out.println("obj"+obj.toString());
			notfind=(!mdl.elementAt(i).equals(obj));
			i++;
		}
		return notfind;
	}
	
	private JRadioButton getJRadioButton() {
		if (jRadioButton == null) {
			JToggleButton.ToggleButtonModel toggleButtonModel = new JToggleButton.ToggleButtonModel();
			toggleButtonModel.setGroup(getButtonGroup());
			jRadioButton = new JRadioButton();
			jRadioButton.setBounds(460, 40, 73, 21);
			jRadioButton.setBackground(java.awt.SystemColor.control);
			jRadioButton.setModel(toggleButtonModel);
			jRadioButton.setText("Avarage");
			jRadioButton.setEnabled(false);
			jRadioButton.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
			jRadioButton.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if (jRadioButton.isSelected()){
						getScrollList().getViewport().add(getOptionImport(true));
						getGraph().setEnabled(true);
			        		optionImport.setEnabled(true);
					}
				}
			});
		}
		return jRadioButton;
	}

	private JRadioButton getJRadioButton1() {
		if (jRadioButton1 == null) {
			JToggleButton.ToggleButtonModel toggleButtonModel1 = new JToggleButton.ToggleButtonModel();
			toggleButtonModel1.setGroup(getButtonGroup());
			jRadioButton1 = new JRadioButton();
			jRadioButton1.setBounds(530, 40, 80, 21);
			jRadioButton1.setBackground(java.awt.SystemColor.control);
			jRadioButton1.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN , 12));
			jRadioButton1.setModel(toggleButtonModel1);
			jRadioButton1.setEnabled(false);
			jRadioButton1.setText("Time line");
			jRadioButton1.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if (jRadioButton1.isSelected()){ 
						getScrollList().getViewport().add(getOptionImport(true));
						getGraph().setEnabled(true);
				        	optionImport.setEnabled(true);
					}
				}
			});
		}
		return jRadioButton1;
	}

	private ButtonGroup getButtonGroup() {
		if (buttonGroup == null) {
			buttonGroup = new ButtonGroup();
		}
		return buttonGroup;
	}

	private JButton getDelButton() {
		if (delbutton == null) {
			delbutton = new JButton();
			delbutton.setBounds(new java.awt.Rectangle(12,180,128,22));
			delbutton.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
			delbutton.setIcon(new ImageIcon(getClass().getResource("images/garbage.png")));
			delbutton.setText("del run");
			delbutton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					int reply = JOptionPane.showConfirmDialog(null,"        Are you sure to delete this run?!!!","Experiment", JOptionPane.YES_NO_OPTION);
					if (reply != JOptionPane.NO_OPTION)
					{
					db.delete("linkData",getComboExpId().getSelectedItem().toString(),getComboExpRunNbr().getSelectedItem().toString());
					db.delete("SenderSide",getComboExpId().getSelectedItem().toString(),getComboExpRunNbr().getSelectedItem().toString());
					db.delete("experiment",getComboExpId().getSelectedItem().toString(),getComboExpRunNbr().getSelectedItem().toString());			
					}	
				}
			});
		}
		return delbutton;
	}
}  


