/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */
import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableModel;
import java.sql.ResultSet;
import java.text.DecimalFormat;
import javax.swing.JScrollPane;
import javax.swing.ImageIcon;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JOptionPane;
import java.awt.Rectangle;
import java.awt.Point;
public class Database_SendReceiver extends JPanel{
	LocationFrame location;
	private JPanel getdata = null;
	private JLabel jLabel = null;
	private JLabel jLabel1 = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JComboBox comboExpId = null;
	private JComboBox comboExpRunNbr = null;
	private JComboBox sender = null;
	private JComboBox receiver = null;
	private JButton Import = null;
	private JPanel jPanel = null;
	private JPanel panelReceiver = null;
	private JPanel panelSender = null;
	private JTable tableExp = null;
	private JTextArea commentdb = null;
	private DBconnection db = new DBconnection();
	private JTable tabledb = null;
	private JTable tableSender = null;
	private JScrollPane jScrollPane1 = null;
	private JScrollPane jScrollPane2 = null;
	private JScrollPane jScrollPane3 = null;
	private ButtonGroup buttonGroup = null;  
	static DefaultListModel listModel = new DefaultListModel();

	public Database_SendReceiver() {
		super();
		initialize();
	}

	private void initialize() {
        this.setSize(new java.awt.Dimension(1250,700));
        this.setLayout(null);
		try{ 
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
		}catch(Exception e){
			e.printStackTrace();	
		} 
		SwingUtilities.updateComponentTreeUI(this);
        this.setBackground(java.awt.SystemColor.control);
        this.setFont(new java.awt.Font("Arial",0,12));
        this.setPreferredSize(new java.awt.Dimension(1200, 224));
        this.add(getGetdata(), null);
        this.add(getJPanel(), null);
        this.add(getPanelReceiver(), null);
        this.add(getPanelSender(), null);
        initTabledb();
        initTableExp();
		initTableSender();
	}
	public void tabbedPaneFocusGained() { 
	    getImport().setEnabled(false);
	    getComboExpId().setEnabled(false);
	    getComboExpRunNbr().setEnabled(false);
	    getReceiver().setEnabled(false);
	    getSender().setEnabled(false);
	    listModel.removeAllElements();
	    getComboExpId().removeAllItems();
	    db.open_a_connection();
	    getComboExpId().addItem("");
	    ResultSet result = db.select("SELECT DISTINCT exp_id FROM experiment order by rownum DESC ;");
	    try {
	        while (result.next()) {
	        	getComboExpId().addItem(result.getString(1));
	        }
	        getComboExpId().setEnabled(true);
	    } catch (Exception e) {e.printStackTrace();}
	}
	private JPanel getGetdata() {
		if (getdata == null) {
			jLabel3 = new JLabel();
			jLabel3.setText("4. Select a receiver ID");
			jLabel3.setForeground(new java.awt.Color(153,153,153));
			jLabel3.setBounds(new Rectangle(899, 20, 141, 24));
			
			jLabel3.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jLabel2 = new JLabel();
			jLabel2.setText("3. Select a sender ID");
			jLabel2.setForeground(new java.awt.Color(153,153,153));
			jLabel2.setBounds(new Rectangle(617, 20, 139, 23));
			
			jLabel2.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jLabel1 = new JLabel();
			jLabel1.setText("2. Select a run number");
			jLabel1.setForeground(new java.awt.Color(153,153,153));
			jLabel1.setBounds(new Rectangle(324, 20, 153, 22));
			
			jLabel1.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			jLabel = new JLabel();
			jLabel.setText("1. Select an experiment ID");
			jLabel.setForeground(new java.awt.Color(153,153,153));
			jLabel.setBounds(new java.awt.Rectangle(8,20,165,22));
			jLabel.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
			getdata = new JPanel();
			getdata.setLayout(null);
			getdata.add(getComboExpId(), null);
			getdata.add(getImport(), null);
			getdata.add(getSender(), null);
			getdata.add(getReceiver(), null);
			getdata.add(getComboExpRunNbr(), null);
			getdata.setBounds(new Rectangle(12, 5, 1235, 88));
			getdata.setBackground(java.awt.SystemColor.control);
			getdata.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Load Experiment data", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.BOLD, 12), new java.awt.Color(51,51,51)));
			getdata.add(jLabel, null);
			getdata.add(jLabel1, null);
			getdata.add(jLabel2, null);
			getdata.add(jLabel3, null);
		}
		return getdata;
	}

	private JComboBox getComboExpId() {
		if (comboExpId == null) {
			comboExpId = new JComboBox();
			comboExpId.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			comboExpId.setBounds(new java.awt.Rectangle(180,20,138,25));
			comboExpId.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					 comboExpIdItemStateChanged(e);
				}
			});
		}
		return comboExpId;
	}

	private void comboExpIdItemStateChanged(java.awt.event.ItemEvent evt) {                                            
	    String sql = null;
	    if (comboExpId.getSelectedIndex() >0){
	    	getComboExpRunNbr().removeAllItems();
	    	getComboExpRunNbr().addItem("");
	    	getComboExpRunNbr().setEnabled(true);
		sql = "SELECT DISTINCT exp_run_nbr FROM experiment Where exp_id = '" + comboExpId.getSelectedItem() + "';";
	        ResultSet result = db.select(sql);
	        try {
	            while (result.next()) {
	                getComboExpRunNbr().addItem(""+result.getInt(1));
	            }
	        } catch (Exception e) {
	            e.printStackTrace();
	        }
	    }
	}

	private JComboBox getComboExpRunNbr() {
		if (comboExpRunNbr == null) {
			comboExpRunNbr = new JComboBox();
			comboExpRunNbr.setBounds(new Rectangle(473, 20, 138, 25));
			comboExpRunNbr.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			comboExpRunNbr.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					comboExpRunNbrItemStateChanged(e);
				}
			});
		}
		return comboExpRunNbr;
	}

	private void comboExpRunNbrItemStateChanged(java.awt.event.ItemEvent evt) {                                                
	    String sql = null;
	    if (comboExpRunNbr.getSelectedIndex() > 0 && comboExpId.getSelectedIndex() > 0){
	    	getSender().removeAllItems();
	    	getSender().addItem("");
	    	getSender().addItem("All");
		sql = "SELECT DISTINCT src_id FROM linkData WHERE exp_id = '" + getComboExpId().getSelectedItem() + "' and " +
	                " exp_run_nbr = '" + comboExpRunNbr.getSelectedItem() + "';";
	        ResultSet result = db.select(sql);
	        try {
	            while (result.next()) {
	            	getSender().addItem(""+result.getInt(1));
	            }
	        } catch (Exception e) {
	            e.printStackTrace();
	        }
	        sender.setEnabled(true);
	    }
	} 

	private JComboBox getSender() {
		if (sender == null) {
			sender = new JComboBox();
			sender.setBounds(new Rectangle(755, 20, 138, 25));
			sender.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
	        sender.addItemListener(new java.awt.event.ItemListener() {
	            public void itemStateChanged(java.awt.event.ItemEvent evt) {
	                senderItemStateChanged(evt);
	            }
	        });
		}
		return sender;
	}

	private void senderItemStateChanged(java.awt.event.ItemEvent evt) {                                        
	    String sql = null;
	    if (sender.getSelectedIndex() > 0){
	    	getReceiver().removeAllItems();
	    	getReceiver().addItem("");
	    	getReceiver().addItem("All");
	        sql = "SELECT DISTINCT rcv_id FROM linkData ";
	        if (sender.getSelectedIndex() == 1)
	            sql += "WHERE exp_id = '" + getComboExpId().getSelectedItem() + "' and exp_run_nbr = '" 
	                    + getComboExpRunNbr().getSelectedItem() + "';";
	        else if (sender.getSelectedIndex() > 1)
	            sql += "WHERE src_id = " + sender.getSelectedItem() + " and exp_id = '" + getComboExpId().getSelectedItem() + 
	                "' and exp_run_nbr = '" + getComboExpRunNbr().getSelectedItem() + "';";
	        ResultSet result = db.select(sql);
	        try {
	           while (result.next()) {
	                receiver.addItem(""+result.getInt(1));
	            }
	        } catch (Exception e) {
	            e.printStackTrace();
	        }
	        receiver.setEnabled(true);
	    }
	} 

	private JComboBox getReceiver() {
		if (receiver == null) {
			receiver = new JComboBox();
			receiver.setBounds(new Rectangle(1035, 20, 138, 25));
			receiver.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			receiver.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					System.out.println("itemStateChanged()");
					receiverItemStateChanged(e);
				}
			});
		}
		return receiver;
	}

	private void receiverItemStateChanged(java.awt.event.ItemEvent evt) {                                          
	    if (receiver.getSelectedIndex() > 0){
	        getImport().setEnabled(true);
	    }
	}  

	private JButton getImport() {
		if (Import == null) {
			Import = new JButton();
			Import.setToolTipText("Click to import data \n from the database");
			Import.setBounds(new Rectangle(1035, 55, 138, 22));
			Import.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
			Import.setIcon(new ImageIcon(getClass().getResource("images/import.png")));
			Import.setText("Import data");
			Import.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					ImportActionPerformed(e);
				}
			});
		}
		return Import;
	}
	private void ImportActionPerformed(java.awt.event.ActionEvent evt) {                                       
	    String error = "";
	    if (getSender().getSelectedIndex()==0)
	        error += "You need select one especific or all sender\n";
	    if (getReceiver().getSelectedIndex()==0)
	        error += "You need select one especific or all receiver\n";
	    if (getComboExpId().getSelectedIndex()==0)
	        error += "You need select one especific experience id\n";
	    if (getComboExpRunNbr().getSelectedIndex()==0)
	        error += "You need select one especific experience run number";
	    if (!error.equals(""))
	        JOptionPane.showMessageDialog(null,error, "Link Quality Estimation and Characterization", JOptionPane.ERROR_MESSAGE);
	    else{
	        selectData ();
		selectDataSender();
	    }
	}   
	
    private void selectData(){
        DefaultTableModel dtm = (DefaultTableModel)getTabledb().getModel();
        for (int i = getTabledb().getRowCount() - 1; i >= 0; i--)
            dtm.removeRow(i);
        selectExperiment();
        String sql = "SELECT src_id, seq_no, exp_id, exp_run_nbr, src_x, src_y, src_z, " +
               "src_timestamp, rcv_id, rcv_x, rcv_y, rcv_z, rcv_timestamp, rtxcount, lqi, rssi, noise, snr, humidity, " +
               "temperature, voltage, light1,light2, pressure FROM linkData WHERE exp_id = '" + 
               getComboExpId().getSelectedItem() + "' and exp_run_nbr = '" + getComboExpRunNbr().getSelectedItem() + "'";
        if (getSender().getSelectedIndex()>1)
            sql += " and src_id = " + getSender().getSelectedItem();
        if (getReceiver().getSelectedIndex()>1)
            sql += " and rcv_id = " + getReceiver().getSelectedItem();
        sql += ";";
        ResultSet result = db.select(sql);
        try {
           while (result.next()) {
    //1src_id, 2seq_no, 3experiment_exp_id, 4experiment_exp_run_nbr, 5src_x, 6src_y, 7src_z,
    //8src_timestamp, 9rcv_id, 10rcv_x, 11rcv_y, 12rcv_z, 13rcv_timestamp, 14rtx, 15lqi, 16rssi, 17nrssi, 18snr,
    //19humidity, 20temperature, 21voltage, 22light, 22pressure FROM linkData
               setTabledb( result.getInt(2), result.getInt(1), result.getInt(9), result.getInt(15), 
                        result.getInt(16), result.getInt(17), result.getFloat(18), result.getString(8), result.getString(13),
                        result.getDouble(19), result.getDouble(20), result.getFloat(21), result.getString(5),
                        result.getString(6), result.getString(7), result.getString(10), result.getString(11), 
                        result.getString(12), result.getFloat(22), result.getFloat(23), result.getInt(24));
               
           }
        } catch (Exception e) {e.printStackTrace();}
    }

    private void selectDataSender(){
        DefaultTableModel dtm = (DefaultTableModel)getTableSender().getModel();
        for (int i = getTableSender().getRowCount() - 1; i >= 0; i--)
            dtm.removeRow(i);

        String sql = "SELECT src_id, seq_no, exp_id, exp_run_nbr, src_timestamp, rcv_id, rtxcount, ackted FROM SenderSide WHERE exp_id = '" + 
               getComboExpId().getSelectedItem() + "' and exp_run_nbr = '" + getComboExpRunNbr().getSelectedItem() + "'";
        if (getSender().getSelectedIndex()>1)
            sql += " and src_id = " + getSender().getSelectedItem();
        if (getReceiver().getSelectedIndex()>1)
            sql += " and rcv_id = " + getReceiver().getSelectedItem();
        sql += ";";
        ResultSet result = db.select(sql);
	int i = 0;
        try {
           while (result.next()) {
		if (result.getInt(2) == 0)
			i =0;
		else
			i ++;
               setTableSender( result.getInt(2), result.getInt(1), result.getInt(6), result.getString(5), result.getInt(7), result.getInt(8), i);
           }
        } catch (Exception e) {e.printStackTrace();}
    }

    private void selectExperiment(){
        String sql = "SELECT exp_date, exp_time, exp_payload_size, exp_inter_pkt_time, exp_nbr_sent_packet, " +
              "exp_nbr_nodes, exp_tx_power, exp_channel, exp_ack_onoff, exp_max_retries, exp_topology, " +
              "exp_node_type, exp_country, exp_city, exp_description FROM experiment WHERE exp_id = '" +
              getComboExpId().getSelectedItem() + "' and exp_run_nbr = '" + getComboExpRunNbr().getSelectedItem() + "';";
       ResultSet result = db.select(sql);
       DefaultTableModel dtm = (DefaultTableModel)tableExp.getModel();
       for (int i = getTableExp().getRowCount() - 1; i >= 0; i--)
           dtm.removeRow(i);
       try {
           while (result.next()) {
               int i = 0;
               dtm.insertRow(i++, new Object[]{"Exp id", getComboExpId().getSelectedItem()});
               dtm.insertRow(i++, new Object[]{"Exp run nbr ", getComboExpRunNbr().getSelectedItem()});
               dtm.insertRow(i++, new Object[]{"Date", result.getString(1)});
               dtm.insertRow(i++, new Object[]{"Time", result.getString(2)});
               dtm.insertRow(i++, new Object[]{"Payload size", result.getString(3)});
               dtm.insertRow(i++, new Object[]{"Inter pkt time", result.getString(4)});
               dtm.insertRow(i++, new Object[]{"Nbr sent pkt", result.getString(5)});
               dtm.insertRow(i++, new Object[]{"Nbr nodes", result.getString(6)});
               dtm.insertRow(i++, new Object[]{"Trans power", result.getString(7)});
               dtm.insertRow(i++, new Object[]{"Channel", result.getString(8)});
               dtm.insertRow(i++, new Object[]{"Ack on/off", result.getBoolean(9)});
               dtm.insertRow(i++, new Object[]{"Max ret", result.getString(10)});
               dtm.insertRow(i++, new Object[]{"Topology", result.getString(11)});
               dtm.insertRow(i++, new Object[]{"Node Type", result.getString(12)});
               dtm.insertRow(i++, new Object[]{"Country", result.getString(13)});
               dtm.insertRow(i++, new Object[]{"City", result.getString(14)});
               getCommentdb().setText(result.getString(15));
           }
       } catch (Exception e) {e.printStackTrace();}
    }

	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jPanel.add(getCommentdb(), null);
			jPanel.setBounds(new Rectangle(650, 100, 597, 260));
			jPanel.setBackground(java.awt.SystemColor.control);
			jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Experiment related info", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.BOLD, 12), new java.awt.Color(51,51,51)));
			jPanel.add(getJScrollPane1(), null);
			
			
		}
		return jPanel;
	}

	private JPanel getPanelReceiver() {
		if (panelReceiver == null) {
			panelReceiver = new JPanel();
			panelReceiver.setBounds(new Rectangle(12, 367, 1235, 310));
			panelReceiver.setBackground(java.awt.SystemColor.control);
			panelReceiver.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Received Messages", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.BOLD, 12), new java.awt.Color(51,51,51)));
			panelReceiver.add(getTabledb(), null);
			panelReceiver.add(getJScrollPane2(), null);
			panelReceiver.setLayout(null);
		}
		return panelReceiver;
	}

	private JPanel getPanelSender() {
		if (panelSender == null) {
			panelSender = new JPanel();
			panelSender.setBackground(java.awt.SystemColor.control);
			panelSender.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Sender Messages", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.BOLD, 12), new java.awt.Color(51,51,51)));
			panelSender.add(getTableSender(), null);
			panelSender.add(getJScrollPane3(), null);
			panelSender.setLayout(null);
			panelSender.setBounds(new Rectangle(12, 100, 621, 260));
		}
		return panelSender;
	}

	private JTable getTableExp() {
		if (tableExp == null) {
			tableExp = new JTable();
			tableExp.setBounds(new java.awt.Rectangle(14,23,257,165));
		        tableExp.setFont(new java.awt.Font("Arial", 0, 14));
		        tableExp.setModel(new javax.swing.table.DefaultTableModel(new Object [][] {}, new String [] {"Property", "value"}){
			Class[] types = new Class [] {java.lang.String.class, java.lang.String.class };
			boolean[] canEdit = new boolean [] {
		       	false, false
		    };
           	public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
			public boolean isCellEditable(int rowIndex, int columnIndex) {
	        	return canEdit [columnIndex];
		    }
	        });
	        tableExp.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
		}
		return tableExp;
	}

	private JTextArea getCommentdb() {
		if (commentdb == null) {
			commentdb = new JTextArea();
			commentdb.setBounds(new Rectangle(310, 18, 262, 232));
			commentdb.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Comments", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			commentdb.setEnabled(false);
		}
		return commentdb;
	}

	private JTable getTabledb() {
		if (tabledb == null) {
			tabledb = new JTable();
	        tabledb.setModel(new javax.swing.table.DefaultTableModel(
	                new Object [][] {

	                },
	                new String [] {
	                    "Seq Number", "Sender", "Receiver", "LQI", "RSSI", "NRSSI", "SNR", "Src TimeStamp", "Rcv TimeStamp", "Rtx", "Humidity", "Temperature", "Voltage", "Light1", "Light2", "Sx", "Sy", "Sz", "Dx", "Dy", "Dz"
	                }
	            ) {
	                Class[] types = new Class [] {
	                    java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
	                };
	                boolean[] canEdit = new boolean [] {
	        		       	false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false
	        		};
	                public Class getColumnClass(int columnIndex) {
	                    return types [columnIndex];
	                }
	                public boolean isCellEditable(int rowIndex, int columnIndex) {
	    	        	return canEdit [columnIndex];
	    		    }
	            }	        
);
	            tabledb.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
		}
		return tabledb;
	}

	private JTable getTableSender() {
		if (tableSender == null) {
			tableSender = new JTable();
			tableSender.setModel(new javax.swing.table.DefaultTableModel(
	                new Object [][] {

	                },
	                new String [] {
	                    "Seq Number", "Sender", "Receiver", "Src TimeStamp", "Rtx", "Acked", "i"
	                }
	            ) {
	                Class[] types = new Class [] {
	                    java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class,
	                };
	                boolean[] canEdit = new boolean [] {
	        		       	false, false, false, false, false, false, false
	        		};
	                public Class getColumnClass(int columnIndex) {
	                    return types [columnIndex];
	                }
	                public boolean isCellEditable(int rowIndex, int columnIndex) {
	    	        	return canEdit [columnIndex];
	    		    }
	            }	        
);
				tableSender.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
		}
		return tableSender;
	}
	
    private void initTabledb(){
    	getTabledb().getColumnModel().getColumn(0).setPreferredWidth(85);//seq number
    	getTabledb().getColumnModel().getColumn(1).setPreferredWidth(60);//sender
    	getTabledb().getColumnModel().getColumn(2).setPreferredWidth(60);//receiver
    	getTabledb().getColumnModel().getColumn(3).setPreferredWidth(65);//lqi
    	getTabledb().getColumnModel().getColumn(4).setPreferredWidth(55);//rssi
    	getTabledb().getColumnModel().getColumn(5).setPreferredWidth(55);//nrssi
    	getTabledb().getColumnModel().getColumn(6).setPreferredWidth(60);//snr
    	getTabledb().getColumnModel().getColumn(7).setPreferredWidth(95);//src time stamp
    	getTabledb().getColumnModel().getColumn(8).setPreferredWidth(95);//rcv time stamp
    	getTabledb().getColumnModel().getColumn(9).setPreferredWidth(55);//rtx
    	getTabledb().getColumnModel().getColumn(10).setPreferredWidth(70);//humidity
    	getTabledb().getColumnModel().getColumn(11).setPreferredWidth(90);//temperature
    	getTabledb().getColumnModel().getColumn(12).setPreferredWidth(60);//voltage
    	getTabledb().getColumnModel().getColumn(13).setPreferredWidth(90);//Light
    	getTabledb().getColumnModel().getColumn(14).setPreferredWidth(90);//Light
    	getTabledb().getColumnModel().getColumn(15).setPreferredWidth(55);//src x
    	getTabledb().getColumnModel().getColumn(16).setPreferredWidth(55);//src y
    	getTabledb().getColumnModel().getColumn(17).setPreferredWidth(55);//src z
    	getTabledb().getColumnModel().getColumn(18).setPreferredWidth(55);//rcv x
    	getTabledb().getColumnModel().getColumn(19).setPreferredWidth(55);//rcv y
    	getTabledb().getColumnModel().getColumn(20).setPreferredWidth(55);//rcv z
    }
    
    private void initTableSender(){
    	getTableSender().getColumnModel().getColumn(0).setPreferredWidth(85);//seq number
    	getTableSender().getColumnModel().getColumn(1).setPreferredWidth(60);//sender
    	getTableSender().getColumnModel().getColumn(2).setPreferredWidth(60);//receiver
    	getTableSender().getColumnModel().getColumn(3).setPreferredWidth(100);//src timestamp
    	getTableSender().getColumnModel().getColumn(4).setPreferredWidth(55);//rtx
    	getTableSender().getColumnModel().getColumn(5).setPreferredWidth(55);//acked
    	getTableSender().getColumnModel().getColumn(6).setPreferredWidth(55);//acked
    }

    private void initTableExp(){
    	tableExp.getColumnModel().getColumn(0).setPreferredWidth(110);
            tableExp.getColumnModel().getColumn(1).setPreferredWidth(130);
        }
    
    public void setTabledb( int seqNumber, int idSender, int receiver, int lqi, int rssi, int nrssi, float snr, String src_ts, String rcv_ts, double hum, double temperature, float voltage, String src_x, String src_y, String src_z, String rcv_x, String rcv_y, String rcv_z, float light1, float light2, int rtx){
        DecimalFormat df = new DecimalFormat("0.00");
        DecimalFormat df2 = new DecimalFormat("0.000");
        DefaultTableModel dtm = (DefaultTableModel)getTabledb().getModel();
	dtm.insertRow(0, new Object[]{seqNumber, idSender, receiver, lqi, rssi, nrssi, snr, src_ts, rcv_ts, rtx,
        df.format(hum), temperature, df2.format(voltage), df.format(light1), df.format(light2), src_x, src_y, src_z, rcv_x, rcv_y, rcv_z});
    }

    public void setTableSender( int seqNumber, int idSender, int receiver, String src_ts, int rtx, int acked, int i) {
        DecimalFormat df = new DecimalFormat("0.00");
        DecimalFormat df2 = new DecimalFormat("0.000");
        DefaultTableModel dtm = (DefaultTableModel)getTableSender().getModel();
	dtm.insertRow(0, new Object[]{seqNumber, idSender, receiver, src_ts, rtx, acked, i});
    }

	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setBounds(new Rectangle(30, 18, 259, 232));
			jScrollPane1.setViewportView(getTableExp());
			
		}
		return jScrollPane1;
	}
	
	private JScrollPane getJScrollPane2() {
		if (jScrollPane2 == null) {
			jScrollPane2 = new JScrollPane();
			jScrollPane2.setViewportView(getTabledb());
			jScrollPane2.setBounds(new Rectangle(15, 18, 1205, 283));
		}
		return jScrollPane2;
	} 
	
	private JScrollPane getJScrollPane3() {
		if (jScrollPane3 == null) {
			jScrollPane3 = new JScrollPane();
			jScrollPane3.setViewportView(getTableSender());
			jScrollPane3.setBounds(new Rectangle(60, 18, 489, 232));
		}
		return jScrollPane3;
	}
	
	boolean searching(DefaultListModel mdl, Object obj)
	{
		boolean notfind=true;
		int i=0;
		while(notfind && (i<mdl.size())){
			//System.out.println("mdl"+mdl.elementAt(i));
			//System.out.println("obj"+obj.toString());
			notfind=(!mdl.elementAt(i).equals(obj));
			i++;
		}
		return notfind;
	}

	private ButtonGroup getButtonGroup() {
		if (buttonGroup == null) {
			buttonGroup = new ButtonGroup();
		}
		return buttonGroup;
	}

} 



