/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */  
import java.awt.BorderLayout;
import java.awt.Color;
import java.sql.ResultSet;
import java.util.List;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

public class GraphTimeLine extends JPanel {
    private DBconnection db = new DBconnection();
    private float max = -100000, min = 100000;
    String read;
    
    public GraphTimeLine(String expId, String expRun, List idSender, List idReceiver, String reading) {
        super(new BorderLayout());
        read = reading;
        db.open_a_connection();
        String sql;
        ResultSet result;
        // create a dataset...
            XYSeriesCollection dataset = new XYSeriesCollection();
            sql = "SELECT " + reading + " FROM linkData WHERE exp_id = '" + expId + "' and exp_run_nbr = '" + expRun + "'";
            for (int i=0; i<idSender.size(); i++){
                for (int z=0; z<idReceiver.size(); z++){
                    result = db.select(sql + " and src_id = " + idSender.get(i) + " and rcv_id = " +idReceiver.get(z)+";");
                    float var;
                    XYSeries series = new XYSeries("Link " + idSender.get(i).toString() + "-"+ idReceiver.get(z).toString());
                    int j = 0;
                    try {
                        while (result.next()) {
                            var = result.getFloat(1);
                            series.add(j++, var);
                            if (max < var)
                                max = var;
                            if (min > var)
                                min = var;
                        }
                    } catch (Exception e) {e.printStackTrace();}
                    if (j > 0)
                        dataset.addSeries(series);
                }
            }
            JFreeChart chart = createChart(dataset);
            ChartPanel chartPanel = new ChartPanel(chart);
            chartPanel.setBorder(BorderFactory.createCompoundBorder(
                    BorderFactory.createEmptyBorder(4, 4, 4, 4),
                    BorderFactory.createLineBorder(Color.black)));
            add(chartPanel);
        db.close_a_connection();
    }

    private JFreeChart createChart(XYDataset dataset) {
        JFreeChart chart = ChartFactory.createXYLineChart(
            read + " Readings",      // chart title
            "pkt",                      // x axis label
            read,                      // y axis label
            dataset,                  // data
            PlotOrientation.VERTICAL, 
            true,                     // include legend
            true,                     // tooltips
            false                     // urls
        );
        
        XYPlot ploty = chart.getXYPlot();
        ploty.getRangeAxis().setRange(min-0.15, max+0.15);
        XYPlot plotx = chart.getXYPlot();

        return chart;
    }
}
