/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */ 
import java.awt.*;
import javax.swing.SwingUtilities;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.UIManager;
import javax.swing.JButton;
import java.awt.Toolkit;
public class MainFrame extends JFrame{
	public TABpanel maintabpanel = new TABpanel();
	JMenuBar br=new JMenuBar();
	JMenu D=new JMenu("File");
	JMenu P=new JMenu("Network");
	JMenu Z=new JMenu("Help");
	JMenuItem Exit=new JMenuItem("Exit");
	JMenuItem Query_Base=new JMenuItem("what's New");
	JMenuItem About=new JMenuItem("About RadiaLE");
	//***************************************//
	/**
	 * This method initializes 
	 * 
	 */
	
	public MainFrame() {
		//
		super();
		initialize();	
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		Dimension dim = new java.awt.Dimension();
		dim = Toolkit.getDefaultToolkit().getScreenSize();
		try{ 
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
		}catch(Exception e){
			e.printStackTrace();	
		} 
		SwingUtilities.updateComponentTreeUI(this);
        this.setSize(dim);
        this.setResizable(true);
        this.setTitle("RadiaLE");
        this.setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
		this.add(maintabpanel);
        D.addSeparator();
        D.add(Exit);
    	Exit.addActionListener(new java.awt.event.ActionListener() {
    		public void actionPerformed(java.awt.event.ActionEvent e) {
    			System.exit(0);	
    		}
    	});
       	Query_Base.addActionListener(new java.awt.event.ActionListener() {
    		public void actionPerformed(java.awt.event.ActionEvent e) {
    			maintabpanel.setSelectedIndex(4);
    		}
    	});
    	About.addActionListener(new java.awt.event.ActionListener() {
    		public void actionPerformed(java.awt.event.ActionEvent e) {
    			AboutF abtf = new AboutF();
    			abtf.getJFrame().setVisible(true);
    		}
    	});
        P.add(Query_Base);
        Z.add(About);
        br.add(D);
        br.add(P);
        br.add(Z);
        this.setJMenuBar(br);        

			this.setIconImage(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/images/topicon.png")));
	}


}  //  @jve:decl-index=0:visual-constraint="43,27"
