/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */ 
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import java.awt.Dimension;
import javax.swing.table.DefaultTableModel;
import java.sql.*;
import java.text.DecimalFormat;

public class NetViewDataPanel extends JPanel{
	private JTable jTable = null;
	private JScrollPane jScrollPane1 = null;
	DBconnection dbconn = new DBconnection();
	Connection connection;
	
	/**
	 * This method initializes 
	 * 
	*/

	public NetViewDataPanel() {
		super();
    	initialize();
	}

	private void initialize() {
	    	//this.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Data from last experiment id and run number", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.PLAIN, 12), new java.awt.Color(51,51,51)));
	    	this.setSize(new Dimension(322, 270));
	    	this.setBackground(java.awt.SystemColor.control);
	    	this.setLayout(null);
	    	this.add(getJScrollPane1(), null);
	    	initjTable();
	}
	
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setBounds(new java.awt.Rectangle(20, 32, 270, 210));
			jScrollPane1.setViewportView(getjTable());
		}
		return jScrollPane1;
	}  
	
	private JTable getjTable() {
		if (jTable == null) {
			jTable = new JTable();
			jTable.setBounds(new java.awt.Rectangle(20, 32, 270, 210));
	        	jTable.setFont(new java.awt.Font("Arial", 0, 14));
	        	jTable.setModel(new javax.swing.table.DefaultTableModel(new Object [][] {}, new String [] {"Property", "value"}){
				Class[] types = new Class [] {java.lang.String.class, java.lang.String.class };
				boolean[] canEdit = new boolean [] {
				       	false, false
				};
				public Class getColumnClass(int columnIndex) {
					return types [columnIndex];
				}
				public boolean isCellEditable(int rowIndex, int columnIndex) {
			        	return canEdit [columnIndex];
			    	}
	        });
	        jTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
		}
		return jTable;
	}

	public void select(int id){
		int i = 0, sun_rssi = 0, sun_lqi = 0, nbr_sent_packet = 0, nbr_nodes = 0;
		float sun_snr = 0, sun_temp = 0, sun_hum = 0, sun_vol = 0, sun_light1 = 0, sun_light2 = 0;
		float average_rssi, average_lqi, average_snr, average_temp, average_hum, average_vol, average_light1, average_light2, prr, x = 0, y = 0;
		String exp_id = "", exp_run_nbr = "";
		DecimalFormat df = new DecimalFormat("0.00");
        	DefaultTableModel dtm = (DefaultTableModel)jTable.getModel();
        	for (i = getjTable().getRowCount() - 1; i >= 0; i--)
        	   dtm.removeRow(i);
		i = 0;		
        	dbconn.open_a_connection();
		
		try{
			Statement stmtt = dbconn.db.createStatement();
			//ResultSet rs = stmtt.executeQuery("select exp_id from linkData where src_id = " + id +" order by exp_id desc;");
			ResultSet rs = stmtt.executeQuery("select exp_id, rownum from experiment order by rownum DESC ;");
                	if (rs.next()) {
				exp_id = rs.getString(1);
				System.out.print("exp_id " +exp_id);
                	}
       		} catch (Exception e) {e.printStackTrace();}

		try{
			Statement stmtt = dbconn.db.createStatement();
			ResultSet rs = stmtt.executeQuery("select exp_run_nbr from linkData where src_id = " + id +" and exp_id = '" + exp_id + "' order by exp_run_nbr desc;");
                	if (rs.next()) {
				exp_run_nbr = rs.getString(1);
				System.out.print(" exp_run_nbr " +exp_run_nbr);
                	}
       		} catch (Exception e) {e.printStackTrace();}

		if (!exp_id.equals("") && !exp_run_nbr.equals("")){
			try{
				Statement stmtt = dbconn.db.createStatement();
				ResultSet rs = stmtt.executeQuery("select exp_nbr_sent_packet, exp_nbr_nodes from experiment where exp_id = '" + exp_id + "' and exp_run_nbr = '" + exp_run_nbr +"';");
	                	if (rs.next()) {
					nbr_sent_packet = rs.getInt(1);
					nbr_nodes = rs.getInt(2);
                		}
				if (id == 1)
					nbr_sent_packet = nbr_sent_packet * (nbr_nodes - 1);
	       		} catch (Exception e) {e.printStackTrace();}

			try{
				Statement stmtt = dbconn.db.createStatement();
				ResultSet rs = stmtt.executeQuery("select rssi, lqi, snr, temperature, humidity, voltage, light1, light2, src_x, src_y from linkData where src_id = " + id +" and exp_id = '" + exp_id + "' and exp_run_nbr = " + exp_run_nbr +";");
        	        	while (rs.next()) {
					i ++;
					sun_rssi += rs.getInt(1);
					sun_lqi += rs.getInt(2);
					sun_snr += rs.getFloat(3);
					sun_temp += rs.getFloat(4);
					sun_hum += rs.getFloat(5);
					sun_vol += rs.getFloat(6);
					sun_light1 += rs.getFloat(7);
					sun_light2 += rs.getFloat(8);
					x = rs.getFloat(9);
					y = rs.getFloat(10);
        	        	}
       			} catch (Exception e) {e.printStackTrace();}

			prr = (float) (i * 100) / nbr_sent_packet;
			System.out.print(" PRR " + df.format(prr)+" %" + "\n");
			average_rssi = (float) sun_rssi / i;
			average_lqi = (float) sun_lqi / i;
			average_snr = (float) sun_snr / i;
			average_temp = sun_temp / i;
			average_hum = sun_hum / i;
			average_vol = sun_vol / i;
			average_light1 = sun_light1 / i;
			average_light2 = sun_light2 / i;
			dtm.insertRow(0, new Object[]{"Node id", ""+id+""});
			//dtm.insertRow(1, new Object[]{"x", df.format(x)});
			dtm.insertRow(1, new Object[]{"exp_run_nbr", exp_run_nbr});
			dtm.insertRow(2, new Object[]{"y", df.format(y)});
			dtm.insertRow(3, new Object[]{"Packet Reception Rate", df.format(prr)+" %"});
       			dtm.insertRow(4, new Object[]{"Average of RSSI", df.format(average_rssi)});
       		        dtm.insertRow(5, new Object[]{"Average of LQI", df.format(average_lqi)});
			dtm.insertRow(6, new Object[]{"Average of SNR", df.format(average_snr)});
       		        dtm.insertRow(7, new Object[]{"Average of temperature", df.format(average_temp) +" °C" });
       		        dtm.insertRow(8, new Object[]{"Average of humidity", df.format(average_hum)});
       		        dtm.insertRow(9, new Object[]{"Average of voltage", df.format(average_vol)});
       		        dtm.insertRow(10, new Object[]{"Average of light 1", df.format(average_light1)});
       		        dtm.insertRow(11, new Object[]{"Average of light 2", df.format(average_light2)});
			this.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Data from exp id: " + exp_id + " and exp run nbr: " +exp_run_nbr, javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.PLAIN, 12), new java.awt.Color(51,51,51)));
		}
		dbconn.close_a_connection();
    }

    private void initjTable(){
    	jTable.getColumnModel().getColumn(0).setPreferredWidth(170);
    	jTable.getColumnModel().getColumn(1).setPreferredWidth(96);
    }

}  //  @jve:decl-index=0:visual-constraint="10,-62"
