/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */ 
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import java.awt.*;
import javax.swing.JButton;
import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.List;

public class Netview extends JPanel {
	public NetViewDataFrame nvdf;
	private JLabel jLabelX = null;
	private JLabel jLabelY = null;
	private JLabel mote[];
	private JLabel number[];
	private int scale = 34;
	private double bufX[];
	private double bufY[];
	private List<String>  bufId = new ArrayList<String>();

	/**
	 * This method initializes 
	 * 
	 */
	public Netview() {
		super();
		initialize();
		mote = new JLabel [80];
		number = new JLabel [80];
	}

	/**
	 * This method initializes this
	 * 
	 */
	public void initialize() {
		this.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Network viewer (max x = 27.5 m and min x = -27.5, max y = 16.5 m and min Y = -16.5)", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.BOLD, 12), new java.awt.Color(51,51,51)));
	    	this.setBackground(java.awt.SystemColor.control);
        	this.setSize(new java.awt.Dimension(742,480));
	    	this.setLayout(null);

	    	jLabelX = new JLabel();
	    	jLabelX.setText("X");
            	jLabelX.setBounds(new java.awt.Rectangle(730,240,20,25));
  	    	jLabelX.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
	    	this.add(jLabelX, null);

	    	jLabelY = new JLabel();
	    	jLabelY.setText("Y");
            	jLabelY.setBounds(new java.awt.Rectangle(380,10,20,20));
  	    	jLabelY.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
	    	this.add(jLabelY, null);
	}
	
	public void paint(int id, double x, double y){
		if (mote[id]==null){
		   boolean repaint = false;
		   boolean paint = false;
		   int x0 = (int) (x * scale) + 370;
		   int y0 = (int) (y * -scale) + 235;
		   if ((x >= -27.5 && x <= 27.5 ) && (y >= -16.5 && y <= 16.5 ))
			paint = true;

		   if ((x0 >= 0 && x0 <= 727) && (y0 >= 0 && y0 <= 454))
		        draw (id, x, y);
		   else if (paint){
			while (!repaint){
			   if (scale > 10)
			      scale = scale - 3;
			   if (scale == 10)
			      scale = 12;
			   x0 = (int) (x * scale) + 370;
		   	   y0 = (int) (y * -scale) + 235;
			   if ((x0 >= 0 && x0 <= 727) && (y0 >= 0 && y0 <= 454)){
			      repaint = true;
			      repaint (scale, id, x, y);
			   }
			}
		   }
		}
	}

	public void draw(int id, double x, double y){
		if (mote[id]==null){
		   int x0 = (int) (x * scale) + 370;
		   int y0 = (int) (y * -scale) + 240;
  		   mote[id] = (JLabel) new JLabel();
		   if (scale > 22){
		   	mote[id].setBounds(new Rectangle(x0, y0, 13, 12));
			mote[id].setIcon(new ImageIcon(getClass().getResource("images/telosb1.gif")));
		  	mote[id].setIconTextGap(0);
		   }
		   else{
		   	mote[id].setBounds(new Rectangle(x0, y0, 11, 10));
			mote[id].setIcon(new ImageIcon(getClass().getResource("images/telosb.gif")));
		  	mote[id].setIconTextGap(0);
		   }
			
		   mote[id].setText(""+ id + " " + x + " " + y);
		   mote[id].addMouseListener(new java.awt.event.MouseAdapter() {
        		public void mouseClicked(java.awt.event.MouseEvent e) {
        			Object object = e.getSource();
	        		for (int j=0; j<mote.length; j++){
        			    if (object == mote[j]){
        			    	System.out.println("\nmouseClicked() ");
					String[] var = mote[j].getText().split(" ");
					double x1 = Double.parseDouble(var[1]);
            				double y1 = Double.parseDouble(var[2]);
					if (nvdf != null)
					   nvdf.setVisible(false);
               			    	nvdf = new NetViewDataFrame ();
					nvdf.Panel.select(Integer.parseInt(var[0].trim()) );
	               			nvdf.setVisible(true);
        	       			int x2 = (int) (x1 * scale)+ 390;
        	       			int y2 = (int) (y1 * -scale) + 240;
        	       			nvdf.setLocation(x2, y2);
        			    }
        			}
        		}
                   });
	        this.add(mote[id], null);
	  	number[id] = (JLabel) new JLabel();
		number[id].setText(""+id+"");
		if (id<10)
		   number[id].setBounds(new java.awt.Rectangle(x0+5,y0+7,20,20));
		else
		   number[id].setBounds(new java.awt.Rectangle(x0+2,y0+7,20,20));
		number[id].setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 8));
		this.add(number[id], null);
		initialize();
		}
	}

	public void repaint (int scal, int id, double x, double y){
		bufId.removeAll(bufId);
		bufX = new double [80];
		bufY = new double [80];
		for (int j=0; j<mote.length; j++){
			if (mote[j] != null){
				String[] var = mote[j].getText().split(" ");
				bufX[j] = Double.parseDouble(var[1]);
				bufY[j] = Double.parseDouble(var[2]);
				bufId.add(""+j+"");
			}
		}
		deleteMotes ();
		if (scal == 12)
			scale = 13;
		else{
			scale = scal;
			bufX[id] = x;
			bufY[id] = y;
			bufId.add(""+id+"");
		}
		int i;
		for (int j=0; j<bufId.size(); j++){
			i = Integer.parseInt( bufId.get(j).toString() );
			if (mote[i] == null){
			    paint(i, bufX[i], bufY[i]);
			}
		}
	}

	public void deleteMotes (){
		scale = 30;
		for (int j=0; j<mote.length; j++){
			if (mote[j] != null){
				mote[j].setVisible(false);
				number[j].setVisible(false);
				mote[j] = null;
				number[j] = null;
			}
		}
		if (nvdf != null)
			nvdf.setVisible(false);
	}

	public void paint (Graphics g){
		super.paint(g);
		g.setColor( Color.black );
		g.drawLine( 5, 245, 735, 245);//x
		g.drawLine( 375, 15, 375, 475);//y
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"

