#ifndef RADIALE_H
#define RADIALE_H

#ifndef TOSH_DATA_LENGTH
#define TOSH_DATA_LENGTH 114//max = 114
#endif

//41 byte
typedef nx_struct Report_msg {
  nx_uint8_t type;//1 to report received msg // 2 to report mission end event // 3 a sender feedback
  nx_uint8_t me;//1
  nx_int16_t mex;//2
  nx_int16_t mey;//2
  nx_int16_t mez;//2
  nx_uint8_t from;//1
  nx_int16_t fromx;//2
  nx_int16_t fromy;//2
  nx_int16_t fromz;//2
  nx_uint16_t r_msg_sqn;//2
  nx_uint32_t mytime;//4
  nx_uint32_t sendertime;//4
  nx_uint8_t retries;//1
  nx_int8_t rssi;//1
  nx_int8_t noise;//1
  nx_uint8_t lqi;//1
  nx_uint16_t ltemperature;//2
  nx_uint16_t lhumidity;//2
  nx_uint16_t llight1;//2
  nx_uint16_t llight2;//2
  nx_uint16_t lvoltage;//2
  nx_uint16_t lpressure;//2
} Report_msg_t;

typedef nx_struct Command_msg {
  //
  // we plan to do two type of traffic
  // synchronised and no synchronised
  // if type is equual to 3 then we choose to use burst traffic
  //
  nx_uint8_t type;// 1 for synchronized traffic  /****/  2 for burst traffic
  //
  nx_uint8_t node1;
  nx_uint8_t node2;
  nx_uint8_t payload_sz;
  nx_int16_t lastseqn;
  //**************** 
  // inter packet interval
  nx_uint16_t ipi;
  //****************
  nx_uint8_t txpower;
  nx_uint8_t channel;
  nx_uint8_t max_retries;
  nx_uint16_t totalpacket;
} Command_msg_t;

typedef nx_struct Lqe_msg {
  nx_uint16_t seqno;
  nx_uint32_t time_stamp;
  nx_uint8_t rtxcount;
  nx_int16_t lx;
  nx_int16_t ly;
  nx_int16_t lz;
} Lqe_msg_t;


enum {
  AM_REPORT_MSG = 1,
};

enum {
  AM_COMMAND_MSG = 2,
};
enum {
  AM_LQE_MSG = 3,
};

#endif

