/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */ 
import java.sql.*;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import java.util.Date;
import java.text.DateFormat;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.awt.Toolkit;
import net.tinyos.message.*;
import net.tinyos.packet.*;
import net.tinyos.util.*;
import java.util.StringTokenizer;
import java.util.*;
import javax.swing.JPanel;
import javax.swing.JOptionPane;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.JRadioButton;
import javax.swing.JTextArea;
import javax.swing.JComboBox;
import javax.swing.JToggleButton;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.ImageIcon;
import java.awt.Font;
import java.awt.Color;
import java.awt.Rectangle;
import javax.swing.BorderFactory;
// the following api are used to store data into files
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
public class Settings extends JPanel implements MessageListener{

	private JLabel jLabel = null;
	private JTextField experiment_id = null;
	private JLabel jLabel1 = null;
	private JTextField experiment_run_nb = null;
	private JLabel jLabel2 = null;
	private JLabel jLabel3 = null;
	private JTextField city = null;
	private JTextField country = null;
	private JLabel jLabel4 = null;
	private JTextField sentpacketcount = null;
	private JTextField interpacketinterval = null;
	private JLabel jLabel6 = null;
	private JTextField payloadsiz = null;
	private JLabel jLabel7 = null;
	private JRadioButton jRadioButton = null;
	private JRadioButton jRadioButton1 = null;
	private JLabel jLabel8 = null;
	private JTextArea jTextArea = null;
	private JLabel jLabel9 = null;
	private JTextField datetime = null;
	private JLabel jLabel10 = null;
	private JTextField retransmicount = null;
	private JLabel jLabel11 = null;
	private JComboBox transmischannel = null;
	private JLabel jLabel12 = null;
	private JComboBox transmispower = null;
	private ButtonGroup buttonGroup = null;  //  @jve:decl-index=0:visual-constraint=""
	private JButton jButton = null;
	private JButton jButton1 = null;	
	private JLabel jLabel13 = null;
	private JLabel jLabel14 = null;
	private JLabel jLabel15 = null;
	private JComboBox jComboBox2 = null;
	//========================================
	Communication communicate=new Communication();// to communicate with motes
	DBconnection dbconn = new DBconnection();// from databasecomm
	int round=1;
	int end;// to compute how much round of test between a couple of nodes we done
	private int finished=0;// if it is equal to two then we diduct that two finishing msg has been received.(signal final trans between a couple of nodes) 
	private int suggest=0;// used when the pc suggest some information about a receiver serial queue status
	private int txpw[] = {31, 27, 23, 19, 15, 11, 7, 3};
     Vector mif = new Vector();// to store current MoteIF
  //******************************************** 
     ReportMsg m1 = new ReportMsg();
     ReportMsg m2 = new ReportMsg();
  //********************************************
    Vector nodes = new Vector();// to store experiment implied/involved nodes
    Vector comports = new Vector();// to store experiment implied/involved com-port
    private int idexp=1;
    private int rownumero=1;
    //********
    DecimalFormat dft = new DecimalFormat("00");
	private JLabel jLabel5 = null;
	private JComboBox trafficpattern = null;
	private JTextField motetyp;
	private JLabel motetype;
	private JLabel jLabel16 = null;
	private JTextField burstwindow = null;//N how many packet per burst
	private JLabel labelround_count = null;
	private JTextField Burst_count = null;//P how many burst
	private Netview ntv;
	//========================================
	// global parameter for the running experiment
		short node1;
	 	short node2;
	 	short payload_sz;
	 	short ipt;
	 	short txpower;
	 	short channel;
	 	short max_retries;
	 	short totalpacket;
	//========================================
		private JLabel jLabel17 = null;
		private JComboBox Environment = null;
		static boolean requestreply;
		ReminderBeep Rbp;
//================================================
// files to store data
		File folder;
		FileWriter rcreceive;
		FileWriter sdsend;
		BufferedWriter outrc;
		BufferedWriter outsd;
		int counterrc=0;
		int countersd=0;
		
		
//============================================ Timer
// code get from http://www.java2s.com/Code/Java/Development-Class/UsejavautilTimertoscheduleatasktoexecuteonce5secondshavepassed.htm
// used to test if a reply has been received from the node
		class ReminderBeep {
  			Toolkit toolkit;
  			Timer timer;
  			Object objecto;
			int nodeg;
  			ReminderBeep(int seconds, Object obj, int nd) {
  			objecto = obj;
  			nodeg = nd;
    		toolkit = Toolkit.getDefaultToolkit();
    		timer = new Timer();
    		timer.schedule(new RemindTask(), seconds * 1000);
  			}
  			class RemindTask extends TimerTask {
    		public void run() {
      		System.out.println("Time's up!");
      		if (!requestreply)
      		{
      		communicate.sendPackets((MoteIF)(objecto),(short)3,(short)-1,(short)nodeg,(short)node1,(short)28,(short)0,(short)31,channel,(short)0,(short)0);
      		timer.schedule(new RemindTask(), 3000);
      		}
      		else	
      		timer.cancel();
    			}
  			}
		}
	public Settings(Netview ntv) {
		super();
		this.ntv = ntv;
		initialize();
		dbconn.open_a_connection();
		try{
		Statement stmtt = dbconn.db.createStatement();
		ResultSet rs = stmtt.executeQuery("select exp_id, rownum from experiment order by rownum DESC ;");
		if (rs.next())
		{	String exp_id = rs.getString(1);
		System.out.print(exp_id);
		 StringTokenizer st = new StringTokenizer(exp_id);
				     st.hasMoreTokens(); 
				     st.nextToken("_");
				     st.hasMoreTokens();
				     idexp =Integer.parseInt(st.nextToken("_"));
				     System.out.print("idexp"+idexp);
				     idexp +=1;
				     rownumero=Integer.parseInt(rs.getString(2));
				     rownumero +=1;				 
				     }
				     }
			catch(Exception v){System.out.println("***"+v.getMessage()+"***");}
			Date d=new Date();
			DateFormat df = new SimpleDateFormat("yyyyMMdd");
			getExperiment_id().setText(Mappingcountrynams(getCountry().getText())+""+df.format(d)+"_"+dft.format(idexp));
	}
//=======================================================================================================
	String Mappingcountrynams(String incountry)
	{
	String map="USA";
	
	if((incountry.toUpperCase()).matches("PORT.*"))
			map="PT";
	else if((incountry.toUpperCase()).matches("T.*N.*"))
		map="TN";
	else if((incountry.toUpperCase()).matches(".*SAUD.*"))
		map="SA";
	else if((incountry.toUpperCase()).matches("FR.*"))
	map="FR";
	return map;
	}
void insert_in_expDB()
{
	Date d = new Date();
	DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
	String eexpid=getExperiment_id().getText();
	String eexprunnb=getExperiment_run_nb().getText();
	String eexpdate=df.format(d);
	String eexptime=d.getHours()+":"+d.getMinutes()+":"+d.getSeconds();
	String eexppayload=getPayloadsiz().getText();
	String eexptxpw=""+(txpw[getTransmispower().getSelectedIndex()]);
	String eexptxchnl=String.valueOf(getTransmischannel().getSelectedItem());
	String eexptopo=String.valueOf(getJComboBox2().getSelectedItem());
	String eexpenv=String.valueOf(getEnvironment().getSelectedItem());
	//implied experiment node
	String eexpimpliednd="";
	for (int i=0;i< Nodeprogramming.getListM().size();i++)
	{
     StringTokenizer st = new StringTokenizer(Nodeprogramming.getListM().getElementAt(i).toString());
     st.hasMoreTokens();
     st.nextToken(",");
     st.hasMoreTokens();
     String tk =st.nextToken(",");
     StringTokenizer st2 = new StringTokenizer(tk);
     st2.hasMoreTokens();
     st2.nextToken(".");
     st2.hasMoreTokens();
     int nodeid=Integer.parseInt(st2.nextToken(".")+"");
     st.hasMoreTokens();
     st.nextToken(",");
     st.hasMoreTokens();
     tk= st.nextToken(",");
     String comport=tk;
     eexpimpliednd+=nodeid+","+comport+"\n";
	}	
	//*****************************************************************
	String eexpcountry=getCountry().getText();
	String eexpcity=getCity().getText();
	String eexpcomment=getJTextArea().getText();
	String eexpnodenb=""+Nodeprogramming.getListM().size();
	String eexpipi=getInterpacketinterval().getText();
	boolean eexpack=getJRadioButton().isSelected();
	String eexpsentpkt=getSentpacketcount().getText();
	String eexprtxcount=getRetransmicount().getText();
	String eexptraffic=String.valueOf(getTrafficpattern().getSelectedItem());
	String eexpburstwindow=getBurstwindow().getText().trim();
	if (getTrafficpattern().getSelectedIndex()==0){
	String eexproundcount=getBurst_count().getText().trim();
	eexpsentpkt=""+(Integer.parseInt(eexpburstwindow)*Integer.parseInt(eexproundcount));
	}
	dbconn.insertExperiment(rownumero,eexpid,eexprunnb,eexpdate,eexptime,eexppayload,eexptxpw,eexptxchnl, 
    		eexptopo,"Telosb",eexpcountry,eexpcity,eexpcomment,eexpnodenb,eexpipi,eexpsentpkt,eexpack,eexprtxcount, 
    		eexptraffic,eexpburstwindow,eexpenv,eexpimpliednd);
    // insert data into backup database 		
    dbconn.insertExperiment2(rownumero,eexpid,eexprunnb,eexpdate,eexptime,eexppayload,eexptxpw,eexptxchnl, 
    		eexptopo,"Telosb",eexpcountry,eexpcity,eexpcomment,eexpnodenb,eexpipi,eexpsentpkt,eexpack,eexprtxcount, 
    		eexptraffic,eexpburstwindow,eexpenv,eexpimpliednd);
}
	void clearallfield()
	{
	getExperiment_run_nb().setText("1");
	Date d = new Date();
	getDatetime().setText(DateFormat.getInstance().format(d));
	getJComboBox2().setSelectedIndex(0);
	getTransmischannel().setSelectedIndex(0);
	getTransmispower().setSelectedIndex(0);
	getSentpacketcount().setText("");
	getPayloadsiz().setText("");
	getCountry().setText("");
	getCity().setText("");
	getBurst_count().setText("1");
	getBurstwindow().setText("1");
	getJTextArea().setText("");
	getMotetyp().setText("Telosb");
	getRetransmicount().setText("0");
	getInterpacketinterval().setText("100");
	DefaultTableModel dtmm = (DefaultTableModel)quickdatabase.getTableRcvPkt().getModel();
	while(dtmm.getRowCount()>0)
	dtmm.removeRow(dtmm.getRowCount()-1);
	}
	double computeSNR(int rssi, int noise)
	{
		double snr;
		snr =(10*Math.log10(((Math.pow(10,((double)(rssi*1.0)/10))/1000) - (Math.pow(10,((double)(noise*1.0)/10))/1000))) +30) - (double)(noise*1.0);
		return snr;
	}
	void fill(){
		getTransmispower().addItem("0");
		getTransmispower().addItem("-1");
		getTransmispower().addItem("-3");
		getTransmispower().addItem("-5");
		getTransmispower().addItem("-7");
		getTransmispower().addItem("-10");
		getTransmispower().addItem("-15");
		getTransmispower().addItem("-25");
		getTransmispower().setSelectedIndex(7);
		
		getTransmischannel().addItem("26");
		getTransmischannel().addItem("25");
		getTransmischannel().addItem("24");
		getTransmischannel().addItem("23");
		getTransmischannel().addItem("22");
		getTransmischannel().addItem("21");
		getTransmischannel().addItem("20");
		getTransmischannel().addItem("19");
		getTransmischannel().addItem("18");
		getTransmischannel().addItem("17");
		getTransmischannel().addItem("16");
		getTransmischannel().addItem("15");
		getTransmischannel().addItem("14");
		getTransmischannel().addItem("13");
		getTransmischannel().addItem("12");
		getTransmischannel().addItem("11");	
		
		getTrafficpattern().addItem("Burst");
		getTrafficpattern().addItem("Synchronized");
		
		getEnvironment().addItem("Indoor");
		getEnvironment().addItem("Outdoor");
		getEnvironment().setSelectedIndex(1);
		
		getJComboBox2().addItem("Linear");
    	getJComboBox2().addItem("Grid");
    	getJComboBox2().addItem("Circular");
    	getJComboBox2().addItem("Random");
		getJComboBox2().setSelectedIndex(2);
    	
	}

	public void messageReceived(int to, Message message) {
	  	
		ReportMsg msg = (ReportMsg)message;
		// msg type 3 --> a msg containing some sender side info like if the packet was ackitted or not
		if (msg.get_type()==3)
			{
			//System.out.println("Sender packet");
			// write each received packet info into the appropriate file
			// these files will be used to fill backup database
			try{
			outsd.write(countersd+"\t"+msg.get_me()+"\t"+msg.get_r_msg_sqn()+"\t"+getExperiment_id().getText()+"\t"+getExperiment_run_nb().getText()+"\t"+msg.get_mytime()+"\t"+msg.get_from()+"\t"+msg.get_retries()+"\t"+msg.get_lqi()+"\n");
			outsd.flush();
			countersd++;
			}
			catch(IOException ioexp){System.out.print("line not written in the file\n");}
		   dbconn.insertSender(getExperiment_id().getText(),getExperiment_run_nb().getText(),""+msg.get_me(), 
		   	""+msg.get_from(),""+msg.get_r_msg_sqn(),""+msg.get_mytime(),""+msg.get_retries(),""+msg.get_lqi());
			return;	
			}
		// msg type 4 --> reciving a reply from the receiver
		// the mechanism is set only for burst traffic
		if (msg.get_type()==4){
		System.out.println("Receive Reply");
		if (getTrafficpattern().getSelectedIndex()== 0)
		{suggest = 1;
		requestreply = true;// receiving a reply so stop requesting if the node has finished its current task or not yet
		}
		}
		// msg type 1 --> reciving a report about the received radio msg
		if (msg.get_type()==1){
		double snr = computeSNR(msg.get_rssi(),(msg.get_noise()-45));
		if (((Double)snr).isNaN())
			snr = 0;
		if (((Double)snr).isInfinite())
			snr = 0;
		int val_temp = msg.get_ltemperature();
	        double temperature = 0.01*val_temp - 40;
	        
	        int valHum = msg.get_lhumidity();
	        double humLin = (-0.0000028*valHum*valHum) + (0.0405*valHum) - 4;
	        double humidity = (temperature-25) * (0.01 + 0.00008*valHum) + humLin;
	        
	        int valVoltage = msg.get_lvoltage();
	        double voltage = (valVoltage / 4096.0) * 1.5;

	        int valLight1 = msg.get_llight1();
	        double light1 = valLight1/4096.0*1.5*10000*0.625;
	      
	        int valLight2 = msg.get_llight2();
	        double light2 = valLight2/4096.0*1.5*10000*0.625;

	        double valPressure = msg.get_lpressure();
	        double pressure = valPressure;

			int expscr_id=msg.get_from();
			int expseq_no=msg.get_r_msg_sqn();
			String eexpid=getExperiment_id().getText();
			String eexprunnb=getExperiment_run_nb().getText();
			long expsrc_time=msg.get_sendertime();
			int exprcv_id=msg.get_me();
			long exprcv_time=msg.get_mytime();
			int explqi=msg.get_lqi();
			int exprssi=msg.get_rssi();
			int expnoise=msg.get_noise()-45;
			int valLocation = msg.get_fromx();
			float src_x = (float) valLocation/100;
		
			valLocation = msg.get_fromy();
			float src_y = (float) valLocation / 100;
			
			valLocation = msg.get_fromz();
			float src_z = (float) valLocation / 100;
			
			valLocation = msg.get_mex();
			float rcv_x = (float) valLocation / 100;
			
			valLocation = msg.get_mey();
			float rcv_y = (float) valLocation / 100;
			
			valLocation = msg.get_mez();
			float rcv_z = (float) valLocation / 100;
			
			int rtx = msg.get_retries();
			try{
			// wrting the needed information into files for filling backup database
			outrc.write(counterrc+"\t"+expscr_id+"\t"+expseq_no+"\t"+getExperiment_id().getText()+"\t"+getExperiment_run_nb().getText()+"\t"+src_x+"\t"+src_y+"\t"+src_z+"\t"+expsrc_time+"\t"+exprcv_id+"\t"+rcv_x+"\t"+rcv_y+"\t"+rcv_z+"\t"+exprcv_time+"\t"+msg.get_retries()+"\t"+explqi+"\t"+exprssi+"\t"+expnoise+"\t"+snr+"\t"+humidity+"\t"+temperature+"\t"+voltage+"\t"+light1+"\t"+light2+"\t"+pressure+"\n");
			outrc.flush();
			counterrc++;
			}
			catch(IOException ioe2){System.out.print("rc no line written in the file\n");}
			System.out.println("****\nReceived packet\n"+"src id " + expscr_id +" rvc id " + exprcv_id+" seq no "+expseq_no + " snr " + snr + "\n");
			this.ntv.paint(exprcv_id, rcv_x, rcv_y);// painting receiver node into network viewer
			dbconn.insertLinkdata(expscr_id,expseq_no,eexpid,eexprunnb,""+expsrc_time,exprcv_id,""+exprcv_time, 
		    		explqi,exprssi,expnoise,snr,humidity,temperature,voltage,light1,light2,pressure,src_x, 
		    		src_y,src_z,rcv_x,rcv_y,rcv_z,rtx);
			quickdatabase.setTable(expscr_id, expseq_no, expsrc_time, exprcv_id, exprcv_time, explqi, exprssi, expnoise, snr, humidity,temperature, voltage, light1, light2, pressure, src_x, src_y, src_z, rcv_x, rcv_y, rcv_z, rtx);	
		  	return;
  		}
  		// reciving finish msg from the Mote
		if (msg.get_type()==2){
			finished+=1;
			System.out.println(msg.get_me()+" finished="+finished);
			//(mif.elementAt(0)) --> node1 ---> mote i
	 	    //(mif.elementAt(1)) --> node2 ---> mote 1
	 	    // if the pc sends a msg type 3 then it is requesting (suggesting) the receiver to send some info about its serial queue status
			//request is set only for burst traffic , no need for the synchronized traffic
			if (getTrafficpattern().getSelectedIndex()==0)
			{
			if (msg.get_me()== node1)			
			{
			requestreply = false;// we didn't receive yet a reply for our request
			communicate.sendPackets((MoteIF)(mif.elementAt(1)),(short)3,(short)-1,(short)node2,(short)node1,(short)28,(short)0,(short)31,channel,(short)0,(short)0);
  			if (Rbp != null)
			Rbp.timer.cancel();
  			Rbp =new ReminderBeep(3,(mif.elementAt(1)),node2);// start a timer of 3 seconds
  			}
			else if (msg.get_me()== node2)
			{
				requestreply = false;// we didn't receive yet a reply for our request
				communicate.sendPackets((MoteIF)(mif.elementAt(0)),(short)3,(short)-1,(short)node1,(short)node2,(short)28,(short)0,(short)31,channel,(short)0,(short)0);
			
			if (Rbp != null)
				Rbp.timer.cancel();
  			Rbp =new ReminderBeep(3,(mif.elementAt(0)),node1);// start a timer of 3 seconds
  			
			}
  			}
  		}
  		//node finish sending & has replied to the request (for burst traffic) then the current communication has terminated
  		// switch to two other motes
  		if (((getTrafficpattern().getSelectedIndex()==1) && (finished==2))||((getTrafficpattern().getSelectedIndex()==0) && (finished==(2*Integer.parseInt(getBurst_count().getText().trim()))) && (suggest==1)))
  		{
  			     finished=0;
  			     suggest=0;
  			     finishing();// recommence : synchronized traffic
  			     return;
		        
  		}
  		if ((getTrafficpattern().getSelectedIndex()== 0)&&(finished>0) && (suggest==1))
  		{
  				suggest = 0;
  				run_burst_experiment();// recommence : burst traffic
  		}
  		
	}


	void finishing(){
	  	if (nodes.size()>=2){
  				try{Thread.sleep(1000);	}
				catch (Exception epxrs)	{	}
		    	(((MoteIF)(mif.elementAt(0))).getSource()).shutdown();
 		    	(((MoteIF)(mif.elementAt(0))).getSource()).interrupt();
		    	((MoteIF)(mif.elementAt(0))).deregisterListener(m1,this);
		    	
		    	(((MoteIF)(mif.elementAt(1))).getSource()).shutdown(); 
		    	(((MoteIF)(mif.elementAt(1))).getSource()).interrupt();
		    	((MoteIF)(mif.elementAt(1))).deregisterListener(m2,this);
		    	mif.removeAllElements();
		    	comports.removeElementAt(comports.size() -1);
		    	nodes.removeElementAt(nodes.size() -1);
	        }	  
		// if node size is less than two --> the current run is ended
		if  (nodes.size()<2) { //at each round we detele the last round involved motes
		try{
			Thread.sleep(2000);
			}
		catch (Exception epxrs)
		{
	
		}
		String st1=getExperiment_id().getText()+"__"+getExperiment_run_nb().getText();
			   	Process p2 = null;
		    	Process p3 = null;
		    	String PROGRAMCMDL1;
		    	String PROGRAMCMDL2;
		    	String PROGRAMCMDW1;
		    	String PROGRAMCMDW2;
		    	// Linux OS
		    	if(System.getProperty("os.name").equals("Linux")) {
      			PROGRAMCMDL1 ="cp outputs/SD"+st1+".txt /var/lib/mysql/backup/";
      			PROGRAMCMDL2 ="cp outputs/RC"+st1+".txt /var/lib/mysql/backup/";
      			try{     			
	      		System.out.println("try to cp file" + PROGRAMCMDL1);
     		 	p2 = Runtime.getRuntime().exec(PROGRAMCMDL1); 
     			p2.waitFor();
     			p3 = Runtime.getRuntime().exec(PROGRAMCMDL2); 
     			p3.waitFor();
     			}
     			catch(Exception etx){System.out.println("error");}
     			}
     			// else windows
      			else{ 
	      			try{
	      		System.out.println("try to cp file");      		
	       		PROGRAMCMDW1="c:\\tinyos\\cygwin\\bin\\bash.exe copyfile "+st1;
	    		System.out.println(PROGRAMCMDW1);
	    		p2 = Runtime.getRuntime().exec(PROGRAMCMDW1); 
	        	p2.waitFor();
	      			}
	        	catch(Exception etx){System.out.print(etx.getMessage());}
	        	 }
        // insert data in the new data base
        try{  
        dbconn.openbackup();
        String query;
        Statement stmtt = dbconn.dbc.createStatement();
        query ="LOAD DATA INFILE 'SD"+getExperiment_id().getText()+"__"+getExperiment_run_nb().getText()+".txt' INTO TABLE SenderSide;";
		ResultSet rs = stmtt.executeQuery(query);
		query ="LOAD DATA INFILE 'RC"+getExperiment_id().getText()+"__"+getExperiment_run_nb().getText()+".txt' INTO TABLE linkData;";
		ResultSet rst = stmtt.executeQuery(query);
		dbconn.closebackup();
		 }
		 catch(Exception qsd){}
		 
		// now try to delete file in the data/backup folder
	   	if(System.getProperty("os.name").equals("Linux")) {
		PROGRAMCMDL1 ="rm /var/lib/mysql/backup/SD"+st1+".txt";
		PROGRAMCMDL2 ="rm /var/lib/mysql/backup/RC"+st1+".txt";
		try{     			
	 	p2 = Runtime.getRuntime().exec(PROGRAMCMDL1); 
		p2.waitFor();
		p3 = Runtime.getRuntime().exec(PROGRAMCMDL2); 
		p3.waitFor();
		}
		catch(Exception etx){}
		}
		// else windows
		else{ 
  			try{
  		System.out.println("try to delete file");
  		
   		PROGRAMCMDW1="c:\\tinyos\\cygwin\\bin\\bash.exe deletefile "+st1;
		System.out.println(PROGRAMCMDW1);
		p2 = Runtime.getRuntime().exec(PROGRAMCMDW1); 
    	p2.waitFor();
  			}
    	catch(Exception etx){System.out.print(etx.getMessage());}
    	 }
    	 ////////////////////////////////////////////////////////////////////// finish
	
		JOptionPane.showMessageDialog(null,"The current experiment has been finished!!!","End",JOptionPane.INFORMATION_MESSAGE);
		    	
		  //**************************************************************
		    	try{
		    	
		    	outrc.close();
		    	outsd.close();
     
		    		}
		    	catch(IOException ioe3){System.out.print("closing problems\n");}    	
		    	nodes.removeAllElements();
		    	comports.removeAllElements();
		    	getJButton().setEnabled(true);
		    	Date d=new Date();
		    	getDatetime().setText(DateFormat.getInstance().format(d));
			System.out.println("fim if (nodes.size()<2)"+nodes.size());
			setExpFields(true);
		}
		else{
		    run_experiment();//run experiment until only mote 0 stay alone
		}
	  }

	/**
	 * This method compute the min inter packet delay ~=RTT
	 * 
	 * RTT: Required Transmission Time
	 * RTT = ((packet length)/telosb_rate + retransmission delay)* retransmission count
	 * telosb_rate= 250kbps
	 * retransmission delay = initial backoff + congestion backoff + ack delay 
	 * the ack delay is equal to 256 jiffies~=8 ms
	 * the initial backoff  [300us - 10ms]
	 * and the congestion backoff  [300us - 2.5ms]
	 * source :
	 * - http://www.mail-archive.com/tinyos-help@millennium.berkeley.edu/msg21081.html
	 * - tinyos-2.x\tos\chips\cc2420\cc2420.h 
	 * so retransmission delay~= 20.5 ms we will consider it as 30 ms
	 */
	void compute_min_ipt()
	{
		double timex = ((Integer.parseInt(getPayloadsiz().getText())*8)/256 + 30 )*(1+ Integer.parseInt(getRetransmicount().getText().toString()))* 1.024;
		jLabel13.setText("Min Interpkt Time:   "+2*(Math.floor(timex)+1)+" ms");
	}
	void run_burst_experiment(){
		totalpacket=(short)(Integer.parseInt(getBurstwindow().getText().trim()));
	 		// at each burst the sensor will send burstwindow packet
	 		System.out.println(""+(((finished/2)*totalpacket)-1));
	 		int lastseqn=((finished/2)*totalpacket)-1;
	 		if ((finished%2)==0)
	 			//burst traffic type of msg =2
	 			//node1 source of the burst node2 receiver of the burst
	 			// finished mod 2=0 node1==i will send the burst
	 			// finished mod 2=1 node2==0 will send the burst
	 			//something like this
	 			//tota
	 		{	System.out.println("Fini__"+finished);// node2 = 1   node1=i
	 			communicate.sendPackets((MoteIF)(mif.elementAt(1)),(short)2,(short)lastseqn,node2,node1,payload_sz,ipt,txpower,channel,max_retries,totalpacket);
	 		
	 		}else
	 			communicate.sendPackets((MoteIF)(mif.elementAt(0)),(short)2,(short)lastseqn,node1,node2,payload_sz,ipt,txpower,channel,max_retries,totalpacket);

		
	}
	void run_experiment(){
		try{
			try{Thread.sleep(2000);}
			catch(Exception e){}
	 	mif.addElement(new MoteIF(BuildSource.makePhoenix("serial@"+comports.elementAt((comports.size()-1)).toString()+":telosb", PrintStreamMessenger.err)));
		mif.addElement(new MoteIF(BuildSource.makePhoenix("serial@"+comports.elementAt(0).toString()+":telosb", PrintStreamMessenger.err)));

	 	((MoteIF)(mif.elementAt(0))).registerListener(m1, this); 
	    ((MoteIF)(mif.elementAt(1))).registerListener(m2, this);

		}
		catch(Exception ept){}
	 	
		node1 = (short)Integer.parseInt(nodes.elementAt((nodes.size()-1)).toString());// mote i
		System.out.println("node1 "+node1);
	 	node2 = (short)Integer.parseInt(nodes.elementAt(0).toString());// mote 1
	 	System.out.println("node2 "+node2);
	 	payload_sz = (short)Integer.parseInt(getPayloadsiz().getText());
	 	ipt = (short)Integer.parseInt(getInterpacketinterval().getText());
	 	txpower = (short)txpw[getTransmispower().getSelectedIndex()];
	 	channel = (short)Integer.parseInt(String.valueOf(getTransmischannel().getSelectedItem()));
	 	max_retries = (short)Integer.parseInt(getRetransmicount().getText());
	 	
	 	///*********** change the channel for both nodes *******************///
	 	//(mif.elementAt(0)) --> node1 ---> mote i
	 	//(mif.elementAt(1)) --> node2 ---> mote 1
	 	communicate.sendPackets((MoteIF)(mif.elementAt(0)),(short)4,(short)-1,(short)node1,(short)node2,(short)28,(short)0,(short)31,channel,(short)0,(short)0);
		communicate.sendPackets((MoteIF)(mif.elementAt(1)),(short)4,(short)-1,(short)node2,(short)node1,(short)28,(short)0,(short)31,channel,(short)0,(short)0);
		
		try{
			Thread.sleep(3000);
			}
		catch (Exception epx)
		{
	
		}
	 	///******************************************************************///
	 	if ((getTrafficpattern().getSelectedIndex())==1)
	 		{totalpacket = (short)Integer.parseInt(getSentpacketcount().getText());
	 		communicate.sendPackets((MoteIF)(mif.elementAt(0)),(short)1,(short)-1,node1,node2,payload_sz,ipt,txpower,channel,max_retries,totalpacket);
		 	communicate.sendPackets((MoteIF)(mif.elementAt(1)),(short)1,(short) -1,node1,node2,payload_sz,ipt,txpower,channel,max_retries,totalpacket);
	 		}
	 	else if ((getTrafficpattern().getSelectedIndex())==0) {

 		// at each burst the sensor will send burstwindow packet
 			//node1 source of the burst node2 receiver of the burst
 			// finished mod 2=0 node1==i will send the burst
 			// finished mod 2=1 node2==0 will send the burst
 			//something like this

 			finished = 0;
 			run_burst_experiment();
	 		}	 		
	}
	private void setExpFields (boolean state){
		getTransmispower().setEnabled(state);
        getTransmischannel().setEnabled(state);
		getTrafficpattern().setEnabled(state);
		getEnvironment().setEnabled(state);
		getJComboBox2().setEnabled(state);
		getInterpacketinterval().setEnabled(state);
		getBurst_count().setEnabled(state);
		getPayloadsiz().setEnabled(state);
		getRetransmicount().setEnabled(state);
		getJRadioButton().setEnabled(state);
		getBurstwindow().setEnabled(state);
		getMotetyp().setEnabled(state);
		getRetransmicount().setEnabled(state);
		getCountry().setEnabled(state);
		getCity().setEnabled(state);
		getJButton().setEnabled(state);
	}

	private void initialize() {
		try{ 
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
		}catch(Exception e){
			e.printStackTrace();	
		} 
		SwingUtilities.updateComponentTreeUI(this);
	
        jLabel17 = new JLabel();
        jLabel17.setBounds(10, 258, 102, 20);
        jLabel17.setForeground(Color.black);
        jLabel17.setText("Environment");
        jLabel17.setFont(new Font("Arial", Font.PLAIN, 12));
        labelround_count = new JLabel();
        labelround_count.setBounds(new java.awt.Rectangle(243,179,108,19));
        labelround_count.setText("Burst count");
        labelround_count.setForeground(java.awt.Color.black);
        labelround_count.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel16 = new JLabel();
        jLabel16.setBounds(new java.awt.Rectangle(243,321,111,21));
        jLabel16.setForeground(java.awt.Color.black);
        jLabel16.setText("Burst window size");
        jLabel16.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel5 = new JLabel();
        jLabel5.setBounds(244, 67, 107, 20);
        jLabel5.setForeground(java.awt.Color.black);
        jLabel5.setText("Traffic pattern");
        jLabel5.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel15 = new JLabel();
        jLabel15.setBounds(new java.awt.Rectangle(10,223,104,20));
        jLabel15.setForeground(java.awt.Color.black);
        jLabel15.setText("Topology");
        jLabel15.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel14 = new JLabel();
        jLabel14.setBounds(new java.awt.Rectangle(244,342,228,29));
        jLabel14.setForeground(java.awt.Color.black);
        jLabel14.setText("Inter packet interval");
        jLabel14.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel13 = new JLabel();
        jLabel13.setBounds(244, 322, 227, 22);
        jLabel13.setVisible(false);
        jLabel13.setForeground(java.awt.Color.black);
        jLabel13.setText("Min Interpkt Interval:");
        jLabel13.setFont(new java.awt.Font("Arial", java.awt.Font.BOLD, 12));
        jLabel12 = new JLabel();
        jLabel12.setBounds(244, 98, 107, 20);
        jLabel12.setForeground(java.awt.Color.black);
        jLabel12.setText("Channel");
        jLabel12.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel11 = new JLabel();
        jLabel11.setBounds(244, 138, 107, 20);
        jLabel11.setForeground(java.awt.Color.black);
        jLabel11.setText("Tx power");
        jLabel11.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel10 = new JLabel();
        jLabel10.setBounds(244, 287, 107, 27);
        jLabel10.setForeground(java.awt.Color.black);
        jLabel10.setText("Retx count");
        jLabel10.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel9 = new JLabel();
        jLabel9.setBounds(new java.awt.Rectangle(8,105,107,20));
        jLabel9.setForeground(java.awt.Color.black);
        jLabel9.setText("Date - Time");
        jLabel9.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel8 = new JLabel();
        jLabel8.setBounds(new java.awt.Rectangle(10,289,107,20));
        jLabel8.setForeground(java.awt.Color.black);
        jLabel8.setText("Description");
        jLabel8.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel7 = new JLabel();
        jLabel7.setBounds(244, 258, 110, 20);
        jLabel7.setForeground(java.awt.Color.black);
        jLabel7.setText("Enable Retx");
        jLabel7.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel6 = new JLabel();
        jLabel6.setBounds(244, 215, 104, 30);
        jLabel6.setForeground(java.awt.Color.black);
        jLabel6.setText("Packet size");
        jLabel6.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel4 = new JLabel();
        jLabel4.setBounds(244, 179, 111, 20);
        jLabel4.setForeground(java.awt.Color.black);
        jLabel4.setText("Number of packets");
        jLabel4.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel3 = new JLabel();
        jLabel3.setBounds(new java.awt.Rectangle(8,185,107,20));
        jLabel3.setForeground(java.awt.Color.black);
        jLabel3.setText("City");
        jLabel3.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel2 = new JLabel();
        jLabel2.setBounds(new java.awt.Rectangle(8,145,107,20));
        jLabel2.setForeground(java.awt.Color.black);
        jLabel2.setText("Country");
        jLabel2.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel1 = new JLabel();
        jLabel1.setBounds(new java.awt.Rectangle(8,65,107,20));
        jLabel1.setText("Experiment run nb");
        jLabel1.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel1.setForeground(java.awt.Color.black);
        jLabel = new JLabel();
        jLabel.setText("Experiment ID");
        jLabel.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
        jLabel.setForeground(java.awt.Color.black);
        jLabel.setBounds(new java.awt.Rectangle(8,25,107,20));
        this.setSize(new java.awt.Dimension(483,480));
        this.setBorder(javax.swing.BorderFactory.createTitledBorder(null, " Experiment Setup", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", java.awt.Font.BOLD, 12), new java.awt.Color(51,51,51)));
        this.setBackground(java.awt.SystemColor.control);
        this.add(jLabel, null);
        this.setLayout(null);
        this.add(getExperiment_id(), null);
        this.add(jLabel1, null);
        this.add(getExperiment_run_nb(), null);
        this.add(jLabel2, null);
        this.add(jLabel3, null);
        this.add(getCity(), null);
        this.add(getCountry(), null);
        this.add(jLabel4, null);
        this.add(getSentpacketcount(), null);
        this.add(getInterpacketinterval(), null);
        this.add(jLabel6, null);
        this.add(getPayloadsiz(), null);
        this.add(jLabel7, null);
        this.add(getJRadioButton(), null);
        this.add(getJRadioButton1(), null);
        this.add(jLabel8, null);
        JScrollPane scrolTextarea = new JScrollPane(getJTextArea());
        scrolTextarea.setBounds(new java.awt.Rectangle(7,321,230,75));
        scrolTextarea.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
        scrolTextarea.setNextFocusableComponent(getTransmischannel());
        this.add( scrolTextarea,null);
        this.add(jLabel9, null);
        this.add(getDatetime(), null);
        this.add(jLabel10, null);
        this.add(getRetransmicount(), null);
        this.add(jLabel11, null);
        this.add(getTransmischannel(), null);
        this.add(jLabel12, null);
        this.add(getTransmispower(), null);
        this.add(getJButton(), null);
        this.add(getJButton1(), null);
        this.add(jLabel13, null);
        this.add(jLabel14, null);
        this.add(jLabel15, null);
        this.add(getJComboBox2(), null);
        this.add(jLabel5, null);
        this.add(getTrafficpattern(), null);
        this.add(getMotetype());
        this.add(getMotetyp());
        this.add(jLabel16, null);
        this.add(getBurst_count(), null);
        this.add(getBurstwindow(), null);
        this.add(labelround_count, null);
        this.add(jLabel17, null);
        this.add(getEnvironment(), null);
        fill();// adding elt to combo box 1
        getButtonGroup().add(getJRadioButton());
        getButtonGroup().add(getJRadioButton1());
    
	}

	/**
	 * This method initializes experiment_id	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getExperiment_id() {
		if (experiment_id == null) {
			experiment_id = new JTextField();
			experiment_id.setBounds(new java.awt.Rectangle(120,23,120,24));
			experiment_id.setEnabled(false);
			experiment_id.setDisabledTextColor(new java.awt.Color(26, 26, 26));
			experiment_id.setToolTipText("<html>Automatically filled<img src=\""+new ImageIcon(getClass().getResource("images/help.png"))+"\"  align=\"left\"></html>");
			experiment_id.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.LOWERED)));
		}
		return experiment_id;
	}

	/**
	 * This method initializes experiment_run_nb	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getExperiment_run_nb() {
		if (experiment_run_nb == null) {
			experiment_run_nb = new JTextField();
			experiment_run_nb.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.LOWERED)));
			experiment_run_nb.setBounds(new java.awt.Rectangle(120,63,120,24));
			experiment_run_nb.setEnabled(false);
			experiment_run_nb.setDisabledTextColor(new java.awt.Color(26, 26, 26));
			experiment_run_nb.setText(""+round);
			experiment_run_nb.setToolTipText("automatically update");
			experiment_run_nb.setNextFocusableComponent(getCity());
			experiment_run_nb.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					if ( e.getKeyChar() == java.awt.event.KeyEvent.VK_ENTER)
							{
						//System.out.println("EnterTyped()");
							 experiment_run_nb.nextFocus();
						//traitement de l'evenement touche entrer du clavier
							}
				}
			});
		}
		return experiment_run_nb;
	}

	/**
	 * This method initializes city	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getCity() {
		if (city == null) {
			city = new JTextField();
			city.setBounds(new java.awt.Rectangle(120,183,120,24));
			city.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			city.setText("Porto");
			city.setNextFocusableComponent(getJComboBox2());
			city.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					if ( (e.getKeyChar() == java.awt.event.KeyEvent.VK_ENTER) ||e.getKeyChar() == java.awt.event.KeyEvent.VK_TAB )
							{
							 city.nextFocus();
							}
				}
			});
			city.addFocusListener(new java.awt.event.FocusAdapter() {   
				public void focusLost(java.awt.event.FocusEvent e) {    
					if (city.getText().trim().equals(""))
							if (Mappingcountrynams(getCountry().getText()).equals("PT"))
									city.setText("Porto");
							else if (Mappingcountrynams(getCountry().getText()).equals("TN"))
								city.setText("Sfax");
				}
				public void focusGained(java.awt.event.FocusEvent e) {
					city.setText("");
				}
			});
		}
		return city;
	}

	private JTextField getCountry() {
		if (country == null) {
			country = new JTextField();
			country.setText ("Portugal");
			country.setBounds(new java.awt.Rectangle(120,143,120,24));
			country.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			country.setNextFocusableComponent(getCity());
			country.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					if ( (e.getKeyChar() == java.awt.event.KeyEvent.VK_ENTER) ||e.getKeyChar() == java.awt.event.KeyEvent.VK_TAB )
							{
							 country.nextFocus();
							}
				}
			});
			country.addFocusListener(new java.awt.event.FocusAdapter() {
				public void focusLost(java.awt.event.FocusEvent e) {
					Date d=new Date();
					DateFormat df = new SimpleDateFormat("yyyyMMdd");
					getExperiment_id().setText(Mappingcountrynams(country.getText())+""+df.format(d)+"_"+dft.format(idexp));
					
				}
			});
		}
		return country;
	}

	private JTextField getSentpacketcount() {
		if (sentpacketcount == null) {
			sentpacketcount = new JTextField();
			sentpacketcount.setBounds(350, 176, 120, 24);
			sentpacketcount.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			sentpacketcount.setNextFocusableComponent(getPayloadsiz());
			sentpacketcount.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					if ( (e.getKeyChar() == java.awt.event.KeyEvent.VK_ENTER) ||e.getKeyChar() == java.awt.event.KeyEvent.VK_TAB )
							{
							 sentpacketcount.nextFocus();
							}
				}
			});
		}
		return sentpacketcount;
	}

	private JTextField getInterpacketinterval() {
		if (interpacketinterval == null) {
			interpacketinterval = new JTextField();
			interpacketinterval.setBounds(new java.awt.Rectangle(243,372,228,24));
			interpacketinterval.setEnabled(false);
			interpacketinterval.setText("100");
			interpacketinterval.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			interpacketinterval.setNextFocusableComponent(getJButton());
			interpacketinterval.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					if ( e.getKeyChar() == java.awt.event.KeyEvent.VK_ENTER)
							{
							 interpacketinterval.nextFocus();
							}
				}
			});
			interpacketinterval.addFocusListener(new java.awt.event.FocusAdapter() {
				public void focusGained(java.awt.event.FocusEvent e) {
					compute_min_ipt();
				}
			});
		}
		return interpacketinterval;
	}
	private JTextField getPayloadsiz() {
		if (payloadsiz == null) {
			payloadsiz = new JTextField();
			payloadsiz.setBounds(350, 220, 120, 24);
			payloadsiz.setForeground(java.awt.SystemColor.activeCaption);
			payloadsiz.setText("28");
			payloadsiz.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			payloadsiz.setNextFocusableComponent(getJRadioButton());
			payloadsiz.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					
					if ( (e.getKeyChar() == java.awt.event.KeyEvent.VK_ENTER) ||e.getKeyChar() == java.awt.event.KeyEvent.VK_TAB ) //constante de la classe KeyEvent )
							{
						try{
							int min=Integer.parseInt(payloadsiz.getText().trim());
							int max=Integer.parseInt(payloadsiz.getText().trim());
						
					
						if((min>= 28) && (max<= 114))
						{	
							getInterpacketinterval().setEnabled(true);
							if (getJRadioButton().isSelected())
							{
								try{
								payloadsiz.setNextFocusableComponent(getRetransmicount());}
								catch(Exception et){}
								
							}
							else{
								payloadsiz.setNextFocusableComponent(getInterpacketinterval());
								compute_min_ipt();
								}
						    payloadsiz.nextFocus();
						}
						else
						{
							Toolkit.getDefaultToolkit().beep();
							JOptionPane.showMessageDialog(null,"<html>Min payload size=28 Max payload size=114!!!<br>       and it should be an interger</html>");
				         }}catch(Exception expt){Toolkit.getDefaultToolkit().beep();
				         JOptionPane.showMessageDialog(null,"Integer value required!","Error",JOptionPane.ERROR_MESSAGE);
				         }}
					
							} }
					);
			
			
			payloadsiz.addFocusListener(new java.awt.event.FocusAdapter() {   
				public void focusGained(java.awt.event.FocusEvent e) {    
					payloadsiz.setForeground(java.awt.SystemColor.BLACK);
					payloadsiz.setText("");
				}
				
				
				public void focusLost(java.awt.event.FocusEvent e) {
					if ((payloadsiz.getText()).trim().equals(""))
					{
						payloadsiz.setForeground(java.awt.SystemColor.activeCaption);
						payloadsiz.setText("min:28  max:114");
					}
					try{
						int minn=Integer.parseInt(payloadsiz.getText());
						int maxx=Integer.parseInt(payloadsiz.getText());
					if ((minn>= 28) && (maxx<= 114))
					{	
						getInterpacketinterval().setEnabled(true);}
				}
				catch(Exception excpt){
					Toolkit.getDefaultToolkit().beep();
					JOptionPane.showMessageDialog(null,"Integer value required!","Error",JOptionPane.ERROR_MESSAGE);}
				}});
		}
		return payloadsiz;
	}
	private JRadioButton getJRadioButton() {
		if (jRadioButton == null) {
			//JToggleButton.ToggleButtonModel toggleButtonModel = new JToggleButton.ToggleButtonModel();

			//toggleButtonModel.setGroup(getButtonGroup());
			jRadioButton = new JRadioButton();
			jRadioButton.setBounds(349, 258, 56, 21);
			jRadioButton.setBackground(java.awt.SystemColor.control);
			//jRadioButton.setModel(toggleButtonModel);
			jRadioButton.setText("Yes");
			jRadioButton.setSelected(true);
			jRadioButton.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
			jRadioButton.setNextFocusableComponent(getRetransmicount());
			jRadioButton.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					if ( e.getKeyChar() == java.awt.event.KeyEvent.VK_ENTER)
							{
						jRadioButton.nextFocus();
							}
				}
			});

			jRadioButton.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if(jRadioButton.isSelected())
						getRetransmicount().setEnabled(true);
					else
						getRetransmicount().setEnabled(false);
				}
			});
				
		}
		return jRadioButton;
	}

	private JRadioButton getJRadioButton1() {
		if (jRadioButton1 == null) {
			//JToggleButton.ToggleButtonModel toggleButtonModel1 = new JToggleButton.ToggleButtonModel();
			//toggleButtonModel1.setGroup(getButtonGroup());
			jRadioButton1 = new JRadioButton();
			jRadioButton1.setBounds(407, 258, 63, 21);
			jRadioButton1.setBackground(java.awt.SystemColor.control);
			jRadioButton1.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN , 12));
			//jRadioButton1.setModel(toggleButtonModel1);
			jRadioButton1.setText("No");
			jRadioButton1.setNextFocusableComponent(getInterpacketinterval());
			jRadioButton1.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					if ( e.getKeyChar() == java.awt.event.KeyEvent.VK_ENTER)
							{
						jRadioButton1.nextFocus();
						compute_min_ipt();
							}
				}
			});
			jRadioButton1.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					if(jRadioButton1.isSelected())
					{
						getRetransmicount().setEnabled(false);
						getRetransmicount().setText("0");
					}
					else
						getRetransmicount().setEnabled(true);
					//
					compute_min_ipt();
					getInterpacketinterval().setEnabled(true);
				}
			});
		}
		return jRadioButton1;
	}


	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
			jTextArea.setLineWrap(false);
			jTextArea.setTabSize(4);
		}
		return jTextArea;
	}

	private JTextField getDatetime() {
		if (datetime == null) {
			datetime = new JTextField();
			datetime.setBounds(new java.awt.Rectangle(120,103,120,24));
			datetime.setEnabled(false);
			datetime.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED), javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.LOWERED)));
			datetime.setDisabledTextColor(new java.awt.Color(26, 26, 26));
			Date d=new Date();
			datetime.setText(DateFormat.getInstance().format(d));
			
		}
		return datetime;
	}

	private JTextField getRetransmicount() {
		if (retransmicount == null) {
			retransmicount = new JTextField();
			retransmicount.setBounds(350, 289, 120, 24);
			retransmicount.setEnabled(true);
			retransmicount.setText("6");
			retransmicount.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));

			retransmicount.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					if (getTrafficpattern().getSelectedIndex()==1)
						retransmicount.setNextFocusableComponent(getInterpacketinterval());
						else
							retransmicount.setNextFocusableComponent(getBurstwindow());
					if ( (e.getKeyChar() == java.awt.event.KeyEvent.VK_ENTER) ||e.getKeyChar() == java.awt.event.KeyEvent.VK_TAB )
							{
						retransmicount.nextFocus();
						compute_min_ipt();
							}
				}
			});
		}
		return retransmicount;
	}
	
	private JComboBox getTransmischannel() {
		if (transmischannel == null) {
			transmischannel = new JComboBox();
			transmischannel.setBounds(350, 100, 120, 24);
			transmischannel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			transmischannel.setNextFocusableComponent(getTransmispower());
			transmischannel.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {
					if ( (e.getKeyChar() == java.awt.event.KeyEvent.VK_ENTER) ||e.getKeyChar() == java.awt.event.KeyEvent.VK_TAB )
							{
						transmischannel.nextFocus();
							}
				}
			});
		}
		return transmischannel;
	}

	private JComboBox getTransmispower() {
		if (transmispower == null) {
			transmispower = new JComboBox();
			transmispower.setBounds(350, 140, 120, 24);
			transmispower.setToolTipText("<html>Values expressed in dBm<img src=\""+new ImageIcon(getClass().getResource("images/help.png"))+"\"  align=\"right\" /></html>");
			transmispower.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			transmispower.setNextFocusableComponent(getSentpacketcount());
			transmispower.addKeyListener(new java.awt.event.KeyAdapter() {
				public void keyTyped(java.awt.event.KeyEvent e) {

					if ( (e.getKeyChar() == java.awt.event.KeyEvent.VK_ENTER) ||e.getKeyChar() == java.awt.event.KeyEvent.VK_TAB )
							{
						transmispower.nextFocus();
							}
				}
			});
		}
		return transmispower;
	}

	private ButtonGroup getButtonGroup() {
		if (buttonGroup == null) {
			buttonGroup = new ButtonGroup();
		}
		return buttonGroup;
	}

	 void getnodesandport()
	 {
	 	for (int i=0;i< Nodeprogramming.getListM().size();i++)
	{
     StringTokenizer st = new StringTokenizer(Nodeprogramming.getListM().getElementAt(i).toString());
     st.hasMoreTokens();
     st.nextToken(",");
     st.hasMoreTokens();
     String tk =st.nextToken(",");
     StringTokenizer st2 = new StringTokenizer(tk);
     st2.hasMoreTokens();
     st2.nextToken(".");
     st2.hasMoreTokens();
     int nodeid=Integer.parseInt(st2.nextToken(".")+"");
     st.hasMoreTokens();
     st.nextToken(",");
     st.hasMoreTokens();
     tk= st.nextToken(",");
     String comport=tk;
	 nodes.addElement(nodeid);
	 comports.addElement(comport);
		}		
	 }
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setBounds(new java.awt.Rectangle(82,424,160,28));
			jButton.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
			jButton.setIcon(new ImageIcon(getClass().getResource("images/(start).gif")));
			jButton.setText("Start");
			jButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					Date d=new Date();
					getDatetime().setText(DateFormat.getInstance().format(d));
					if (getCountry().getText().length() < 1)
					{
						Toolkit.getDefaultToolkit().beep();
						JOptionPane.showMessageDialog(null,"You should complete all the fields","missing fields",JOptionPane.ERROR_MESSAGE);
					return;}
					if (Nodeprogramming.getListM().size()<2)
						{
							Toolkit.getDefaultToolkit().beep();
							JOptionPane.showMessageDialog(null,"You should select at least two nodes","insufficient selected node number",JOptionPane.ERROR_MESSAGE);
						}
					else
					{
					getnodesandport();
					getExperiment_run_nb().setText(""+round);
					round++;
					int reply = JOptionPane.showConfirmDialog(null,"        Confirm starting the run ?","Experiment", JOptionPane.YES_NO_OPTION);
					if (reply == JOptionPane.NO_OPTION)
					{
					round--;
					}
					else
					{
					
					JOptionPane.showMessageDialog(null,"Running Experiment ...please wait for a notification!!!","Experiment",JOptionPane.INFORMATION_MESSAGE);
					
					ntv.deleteMotes();

					insert_in_expDB();
					// preparing folder: we will store data into files to fill after backup database
					// first step we open a file in writing mode
					counterrc=1;
					countersd=1;
					folder = new File("outputs");
					if(!folder.exists()) {
					folder.mkdirs();
					}
					try{
					if(System.getProperty("os.name").equals("Linux")) {
    				  rcreceive=new FileWriter(folder.getAbsolutePath()+"/RC"+getExperiment_id().getText()+"__"+getExperiment_run_nb().getText()+".txt");
    				  sdsend=new FileWriter(folder.getAbsolutePath()+"/SD"+getExperiment_id().getText()+"__"+getExperiment_run_nb().getText()+".txt");
					}
					else
					{
					  rcreceive=new FileWriter(folder.getAbsolutePath()+"\\RC"+getExperiment_id().getText()+"__"+getExperiment_run_nb().getText()+".txt");
    				  sdsend=new FileWriter(folder.getAbsolutePath()+"\\SD"+getExperiment_id().getText()+"__"+getExperiment_run_nb().getText()+".txt");
					
					}
				      outrc= new BufferedWriter(rcreceive);
				      outsd= new BufferedWriter(sdsend);
					}
					catch(IOException ioexp){}
				      
					run_experiment();
					setExpFields(false);
					}
					}
				}
			});
		}
		return jButton;
	}

	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setBounds(new java.awt.Rectangle(300,424,160,28));
			jButton1.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
			jButton1.setIcon(new ImageIcon(getClass().getResource("images/new_exp.png")));
			jButton1.setText("New experiment");
			jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {				
					round = 1;
		try{
		
		Statement stmtt = dbconn.db.createStatement();
		ResultSet rs = stmtt.executeQuery("select exp_id, rownum from experiment order by rownum DESC ;");
		if (rs.next())
		{	String exp_id = rs.getString(1);
		System.out.print(exp_id);
		 StringTokenizer st = new StringTokenizer(exp_id);
				     st.hasMoreTokens(); 
				     st.nextToken("_");
				     st.hasMoreTokens();
				     idexp =Integer.parseInt(st.nextToken("_"));
				     System.out.print("idexp"+idexp);
				     idexp +=1;
				     rownumero=Integer.parseInt(rs.getString(2));
				     rownumero +=1;
				     
				     }
				     }
				 catch(Exception v){System.out.println("***"+v.getMessage()+"***");}
					getExperiment_id().setText("");
					clearallfield();					
				}
			});
		}
		return jButton1;
	}

	private JComboBox getJComboBox2() {
		if (jComboBox2 == null) {
			jComboBox2 = new JComboBox();
			jComboBox2.setBounds(new java.awt.Rectangle(120,221,120,25));
			jComboBox2.setNextFocusableComponent(getJTextArea());
			jComboBox2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
		}
		
		return jComboBox2;
	}

	private JComboBox getTrafficpattern() {
		if (trafficpattern == null) {
			trafficpattern = new JComboBox();
			trafficpattern.setBounds(350, 63, 120, 24);
			trafficpattern.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
			trafficpattern.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {				
					if (trafficpattern.getSelectedIndex()==1)
						{jLabel13.setVisible(true);
						
					jLabel16.setVisible(false);
					getBurstwindow().setVisible(false);
					getBurstwindow().setText("0");
					getBurst_count().setVisible(false);
					labelround_count.setVisible(false);
					jLabel4.setVisible(true);
					getSentpacketcount().setVisible(true);
						}
					else
					{
						jLabel13.setVisible(false);
						jLabel16.setVisible(true);
						getBurstwindow().setVisible(true);
						getBurstwindow().setText("10");
						getBurst_count().setVisible(true);
						labelround_count.setVisible(true);
						jLabel4.setVisible(false);
						getSentpacketcount().setVisible(false);
						
					}
				}
			});
		}
		return trafficpattern;
	}
	
	private JLabel getMotetype() {
		if (motetype == null) {
			motetype = new JLabel();
			motetype.setText("Mote type");
			motetype.setFont(new java.awt.Font("Arial", java.awt.Font.PLAIN, 12));
			motetype.setForeground(java.awt.Color.black);
			motetype.setBounds(244, 20, 91, 28);
		}
		return motetype;
	}
	
	private JTextField getMotetyp() {
		if (motetyp == null) {
			motetyp = new JTextField();
			motetyp.setText("Telosb");
			motetyp.setBounds(349, 25, 120, 24);
			motetyp.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
		}
		return motetyp;
	}

	//N variable
	private JTextField getBurstwindow() {
		if (burstwindow == null) {
			burstwindow = new JTextField();
			burstwindow.setBounds(350, 319, 120, 24);
			burstwindow.setBorder(BorderFactory.createLineBorder(new Color(14, 172, 227), 1));
			burstwindow.setText("10");
			burstwindow.setEnabled(true);
		}
		return burstwindow;
	}

	//P variable
	private JTextField getBurst_count() {
		if (Burst_count == null) {
			Burst_count = new JTextField();
			Burst_count.setText("2");
			Burst_count.setBounds(new java.awt.Rectangle(351,176,118,24));
			Burst_count.setBorder(BorderFactory.createLineBorder(new Color(14, 172, 227), 1));
			Burst_count.setNextFocusableComponent(getPayloadsiz());
		}
		return Burst_count;
	}
	private JComboBox getEnvironment() {
		if (Environment == null) {
			Environment = new JComboBox();
			Environment.setBounds(120,257,120,24);
			Environment.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(14,172,227),1));
		}
		return Environment;
	}

}
