/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */ 
import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.JTabbedPane;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
public class TABpanel extends JTabbedPane{
	Netview ntv;
	Settings stg;
	Nodeprogramming m = new Nodeprogramming();
	database_sender dbs = new database_sender();
	Database_Query dbq = new Database_Query();
	Database_SendReceiver dbsr = new Database_SendReceiver ();
	quickdatabase viewData = new quickdatabase();
	private JPanel jPanel = null;
	private JPanel jPanel1 = null;
	private JPanel jPanel2 = null;
	private JPanel jPanel3 = null;
	private JPanel jPanel4 = null;

	/**
	 * This method initializes 
	 * 
	 */
	public TABpanel() {
		super();
		ntv = new Netview();
		stg = new Settings(ntv);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
       	try{ 
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName()); 
		}catch(Exception e){
			e.printStackTrace();	
		} 
		SwingUtilities.updateComponentTreeUI(this);  
        	dbq.addFocusListener(new java.awt.event.FocusAdapter() {
        	public void focusGained(java.awt.event.FocusEvent e) {		
        	}
        	});
        	this.setSize(new java.awt.Dimension(1240,700));
	        this.addTab("Experiment setup", getJPanel());
	       	this.addTab("Receiver result", getJPanel1());
			this.addTab("Sender result", getJPanel3());
			this.addTab("Sender and receiver result", getJPanel4());
        	this.addTab("Quick database inspect", getJPanel2());
        	this.addChangeListener(new javax.swing.event.ChangeListener() {
        	public void stateChanged(javax.swing.event.ChangeEvent e) {   		 
        		if(((JTabbedPane) e.getSource()).getSelectedIndex()==1)
        			dbq.tabbedPaneFocusGained();// selecting Receiver result tabpane
        	}
		});
		this.addChangeListener(new javax.swing.event.ChangeListener() {
        	public void stateChanged(javax.swing.event.ChangeEvent e) {
        		if(((JTabbedPane) e.getSource()).getSelectedIndex()==2)
	        		dbs.tabbedPaneFocusGained();// selecting Sender result tabpane
        		}
        		});
		this.addChangeListener(new javax.swing.event.ChangeListener() {
        	public void stateChanged(javax.swing.event.ChangeEvent e) {
        		if(((JTabbedPane) e.getSource()).getSelectedIndex()==3)// selecting Sender and receiver result tabpane
	        		dbsr.tabbedPaneFocusGained();
        	}
        	});
	}
	JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jPanel.setBackground(java.awt.SystemColor.control);
	        m.setBounds(5,5,1267,195);
	        ntv.setBounds(5,197,742,480);
	        stg.setBounds(765,197,504,480);
	        jPanel.add(m);
	        jPanel.add(ntv);
	        jPanel.add(stg);

		}
		return jPanel;
	}
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(null);
			jPanel1.setBackground(java.awt.SystemColor.control);
			dbq.setBounds(5,5,1200,665);
			jPanel1.add(dbq);
		}
		return jPanel1;
	}
	public JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
			jPanel2.setLayout(null);
			jPanel2.setBackground(java.awt.SystemColor.control);
			viewData.setBounds(5,5,1250,665);
			jPanel2.add(viewData);
		}
		return jPanel2;
	}
	private JPanel getJPanel3() {
		if (jPanel3 == null) {
			jPanel3 = new JPanel();
			jPanel3.setLayout(null);
			jPanel3.setBackground(java.awt.SystemColor.control);
			viewData.setBounds(5,5,1250,665);
			jPanel3.add(dbs);
		}
		return jPanel3;
	}

	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			jPanel4 = new JPanel();
			jPanel4.setLayout(null);
			jPanel4.setBackground(java.awt.SystemColor.control);
			viewData.setBounds(5,5,1250,665);
			jPanel4.add(dbsr);
		}
		return jPanel4;
	}

} 
