import java.awt.BorderLayout;
import java.awt.Color;
import java.sql.ResultSet;
import java.util.List;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;


import java.awt.Color;
import java.awt.Dimension;
import java.text.NumberFormat;
import org.jfree.chart.*;
import org.jfree.chart.axis.*;
import org.jfree.chart.plot.*;
import org.jfree.chart.renderer.category.LineAndShapeRenderer;
import org.jfree.chart.title.TextTitle;
import org.jfree.data.DataUtilities;
import org.jfree.data.DefaultKeyedValues;
import org.jfree.data.general.DatasetUtilities;
import org.jfree.ui.ApplicationFrame;
import org.jfree.ui.RefineryUtilities;
import org.jfree.util.SortOrder;


public class Graph extends JPanel {
    private DBconnection db = new DBconnection();
    private float max = -1000, min = 1000;
    String read;
    
    public Graph(String expId, String expRun, List idSender, List idReceiver, String reading) {
        super(new BorderLayout());
        read = reading;
        db.open_a_connection();
        String sql;
        ResultSet result;
        // create a dataset...
           XYSeriesCollection dataset = new XYSeriesCollection();
            sql = "SELECT " + reading + " FROM linkData WHERE exp_id = '" + expId + 
                    "' and exp_run_nbr = '" + expRun + "'";
            for (int i=0; i<idSender.size(); i++){
                for (int z=0; z<idReceiver.size(); z++){
                    result = db.select(sql + " and src_id = " + idSender.get(i) + " and rcv_id = " +idReceiver.get(z)+";");
                    float var;
                    XYSeries series = new XYSeries("Link " + idSender.get(i).toString() + "-"+ idReceiver.get(z).toString());
                    int j = 0;
                    try {
                        while (result.next()) {
                            var = result.getFloat(1);
                            series.add(j++, var);
                            if (max < var)
                                max = var;
                            if (min > var)
                                min = var;
                        }
                    } catch (Exception e) {e.printStackTrace();}
                    if (j > 0)
                        dataset.addSeries(series);
                }
            }
            JFreeChart chart = createChart(dataset);
            ChartPanel chartPanel = new ChartPanel(chart);
            chartPanel.setBorder(BorderFactory.createCompoundBorder(
                    BorderFactory.createEmptyBorder(4, 4, 4, 4),
                    BorderFactory.createLineBorder(Color.black)));
            add(chartPanel);
        db.close_a_connection();
    }

    private JFreeChart createChart(XYDataset dataset) {
        JFreeChart chart = ChartFactory.createXYLineChart(
            read + " Readings",      // chart title
            "pkt",                      // x axis label
            read,                      // y axis label
            dataset,                  // data
            PlotOrientation.VERTICAL, 
            true,                     // include legend
            true,                     // tooltips
            false                     // urls
        );
        
        XYPlot ploty = chart.getXYPlot();
        ploty.getRangeAxis().setUpperBound(max+2);
        ploty.getRangeAxis().setLowerBound(min-2);
       ///////ploty.getRangeAxis().setRange(min-0.15, max+0.15);
        XYPlot plotx = chart.getXYPlot();
        //plotx.getDomainAxis().setLowerMargin(0.0);
        //plotx.getDomainAxis().setUpperMargin(0.0);
        //plotx.getDomainAxis().setRangeWithMargins(0.0, 0.0);
        return chart;
    }


    public void ParetoChartdemo(String s)
    {
        //super(s);
        DefaultKeyedValues defaultkeyedvalues = new DefaultKeyedValues();
        defaultkeyedvalues.addValue("C", new Integer(4843));
        defaultkeyedvalues.addValue("C++", new Integer(2098));
        defaultkeyedvalues.addValue("C#", new Integer(26));
        defaultkeyedvalues.addValue("Java", new Integer(1901));
        defaultkeyedvalues.addValue("Perl", new Integer(2507));
        defaultkeyedvalues.addValue("PHP", new Integer(1689));
        defaultkeyedvalues.addValue("Python", new Integer(948));
        defaultkeyedvalues.addValue("Ruby", new Integer(100));
        defaultkeyedvalues.addValue("SQL", new Integer(263));
        defaultkeyedvalues.addValue("Unix Shell", new Integer(485));
        defaultkeyedvalues.sortByValues(SortOrder.DESCENDING);
        org.jfree.data.KeyedValues keyedvalues = DataUtilities.getCumulativePercentages(defaultkeyedvalues);
        org.jfree.data.category.CategoryDataset categorydataset = DatasetUtilities.createCategoryDataset("Languages", defaultkeyedvalues);
        JFreeChart jfreechart = ChartFactory.createBarChart("Freshmeat Software Projects", "Language", "Projects", categorydataset, PlotOrientation.VERTICAL, true, true, false);
        jfreechart.addSubtitle(new TextTitle("By Programming Language"));
        jfreechart.addSubtitle(new TextTitle("As at 5 March 2003"));
        jfreechart.setBackgroundPaint(Color.white);
        CategoryPlot categoryplot = jfreechart.getCategoryPlot();
        categoryplot.setBackgroundPaint(Color.lightGray);
        categoryplot.setRangeGridlinePaint(Color.white);
        CategoryAxis categoryaxis = categoryplot.getDomainAxis();
        categoryaxis.setLowerMargin(0.02D);
        categoryaxis.setUpperMargin(0.02D);
        categoryaxis.setCategoryLabelPositions(CategoryLabelPositions.UP_90);
        NumberAxis numberaxis = (NumberAxis)categoryplot.getRangeAxis();
        numberaxis.setStandardTickUnits(NumberAxis.createIntegerTickUnits());
        LineAndShapeRenderer lineandshaperenderer = new LineAndShapeRenderer();
        org.jfree.data.category.CategoryDataset categorydataset1 = DatasetUtilities.createCategoryDataset("Cumulative", keyedvalues);
        NumberAxis numberaxis1 = new NumberAxis("Percent");
        numberaxis1.setNumberFormatOverride(NumberFormat.getPercentInstance());
        categoryplot.setRangeAxis(1, numberaxis1);
        categoryplot.setDataset(1, categorydataset1);
        categoryplot.setRenderer(1, lineandshaperenderer);
        categoryplot.mapDatasetToRangeAxis(1, 1);
        categoryplot.setDatasetRenderingOrder(DatasetRenderingOrder.FORWARD);
        ChartPanel chartpanel = new ChartPanel(jfreechart);
        chartpanel.setPreferredSize(new Dimension(550, 270));
        setContentPane(chartpanel);
    }
}
