/*        
 * "Copyright (c) ReDCAD (Research Unit of Development and Control of Distributed Applications).
 * "Copyright (c) CISTER (Research  Centre in Real-Time Computing Systems) 
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 *
 * IN NO EVENT SHALL REDCAD AND CISTER RESEARCH UNITS BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF REDCAD AND CISTER RESEARCH UNITS 
 * HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * REDCAD AND CISTER RESEARCH UNITS DISCLAIM ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND REDCAD AND CISTER RESEARCH UNITS HAVE NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 */
 /* Authors:    Maissa Ben Jamaa <mbenj@redcad.org>, Denis do Rosrio <dlr@isep.ipp.pt>
  *				Nouha Baccour <nabr@isep.ipp.pt>, Anis Koubaa <aska@isep.ipp.pt>,
  *				Mrio Alves <mjf@isep.ipp.pt>, Habib Youssef <habib.youssef@fsm.rnu.tn>, Leandro Becker <lbecker@das.ufsc.br>
  *				
  * Date: February 1 2010
  * Desc: ExpCtrApp v 1.0
 *              
 */ 

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
public class quickdatabase extends JPanel{
	
	private JScrollPane jScrollPane = null;
	private static JTable tableRcvPkt = null;

	/**
	 * This method initializes 
	 * 
	 */
	public quickdatabase() {
		super();

		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
        this.setSize(new java.awt.Dimension(1250,700));
        this.add(getJScrollPane(), null);
        this.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Received Packet", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION));
        this.setLayout(null);
        inittblrcv();



	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getTableRcvPkt());
			jScrollPane.setBounds(15,20,1220,630);
		}
		return jScrollPane;
	}

	/**
	 * This method initializes TableRcvPkt	
	 * 	
	 * @return javax.swing.JTable	
	 */
	void inittblrcv()
	{
		getTableRcvPkt().getColumnModel().getColumn(0).setPreferredWidth(55);//seq number
		getTableRcvPkt().getColumnModel().getColumn(1).setPreferredWidth(50);//source id
		getTableRcvPkt().getColumnModel().getColumn(2).setPreferredWidth(50);//receiver id
		getTableRcvPkt().getColumnModel().getColumn(3).setPreferredWidth(45);//lqi
		getTableRcvPkt().getColumnModel().getColumn(4).setPreferredWidth(45);//rssi
		getTableRcvPkt().getColumnModel().getColumn(5).setPreferredWidth(45);//nrssi
		getTableRcvPkt().getColumnModel().getColumn(6).setPreferredWidth(45);//snr
		getTableRcvPkt().getColumnModel().getColumn(7).setPreferredWidth(100);//source timestamp
		getTableRcvPkt().getColumnModel().getColumn(8).setPreferredWidth(100);//receiver timestamp
		getTableRcvPkt().getColumnModel().getColumn(9).setPreferredWidth(70);//humidity
		getTableRcvPkt().getColumnModel().getColumn(10).setPreferredWidth(90);//temperature
		getTableRcvPkt().getColumnModel().getColumn(11).setPreferredWidth(60);//voltage
		getTableRcvPkt().getColumnModel().getColumn(12).setPreferredWidth(55);//light
		getTableRcvPkt().getColumnModel().getColumn(13).setPreferredWidth(55);//light
		getTableRcvPkt().getColumnModel().getColumn(14).setPreferredWidth(60);//pressure
		getTableRcvPkt().getColumnModel().getColumn(15).setPreferredWidth(45);//source x
		getTableRcvPkt().getColumnModel().getColumn(16).setPreferredWidth(45);//source y
		getTableRcvPkt().getColumnModel().getColumn(17).setPreferredWidth(45);//source z
		getTableRcvPkt().getColumnModel().getColumn(18).setPreferredWidth(45);//receiver x
		getTableRcvPkt().getColumnModel().getColumn(19).setPreferredWidth(45);//receiver y
		getTableRcvPkt().getColumnModel().getColumn(20).setPreferredWidth(45);//receiver z
		getTableRcvPkt().getColumnModel().getColumn(21).setPreferredWidth(40);//rtx
	}
	public static JTable getTableRcvPkt() {
		if (tableRcvPkt == null) {
			tableRcvPkt = new JTable();
	        tableRcvPkt.setFont(new java.awt.Font("DejaVu Sans", 0, 14));
	       tableRcvPkt.setModel(new javax.swing.table.DefaultTableModel( new Object [][] {},new String [] {"Seq No", "Src id", "Rcv id", "LQI", "RSSI", "NRSSI", "SNR", "Src TimeStamp", "Rcv TimeStamp", "Humidity", "Temperature", "Voltage", "Light1", "Light2", "Pressure", "Src X", "Src Y", "Src Z", "Rcv X", "Rcv Y", "Rcv Z", "rtx"}) {Class[] types = new Class [] {java.lang.Integer.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class};       
	            public Class getColumnClass(int columnIndex) {
	                return types [columnIndex];
	            }
	        });
	        tableRcvPkt.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
			
		}

		return tableRcvPkt;
	}
	
	// receive packet --> update table
    public static void setTable(int src_id, int seq_no, long src_timestamp, int rcv_id, long rcv_timestamp, int lqi, 
            int rssi, int nrssi, double snr, double humidity, double temperature, double voltage, double light1, double light2, 
            double pressure, float src_x, float src_y, float src_z, float rcv_x, float rcv_y, float rcv_z, int rtx){
        DefaultTableModel dtm = (DefaultTableModel)getTableRcvPkt().getModel();
	dtm.insertRow(0, new Object[]{seq_no, src_id, rcv_id, lqi, rssi, nrssi, snr, src_timestamp, rcv_timestamp, 
                  humidity, temperature, voltage, light1, light2, pressure, src_x, src_y, src_z, rcv_x, rcv_y, rcv_z, rtx});
    }

}  //  @jve:decl-index=0:visual-constraint="10,10"
