CREATE TABLE experiment (
  rownum BIGINT NOT NULL,
  exp_id VARCHAR(45) NOT NULL,
  exp_run_nbr INT NOT NULL,
  exp_date DATE NULL,
  exp_time VARCHAR(45) NULL,
  exp_payload_size INT NULL,
  exp_inter_pkt_time INT NULL,
  exp_nbr_sent_packet INT NULL,
  exp_nbr_nodes INT NULL,
  exp_tx_power INT NULL,
  exp_channel INT NULL,
  exp_ack_onoff varchar(6) NULL,
  exp_max_retries INT NULL,
  exp_topology VARCHAR(45) NULL,
  exp_node_type VARCHAR(45) NULL,
  exp_country VARCHAR(45) NULL,
  exp_city VARCHAR(45) NULL,
  exp_traffic VARCHAR(20) NULL,
  exp_description LONGTEXT NULL,
  exp_place VARCHAR(20) NULL,
  exp_implied_nodes LONGTEXT NULL,
  exp_burst_window INT NULL,
  PRIMARY KEY(exp_id, exp_run_nbr)
);

CREATE TABLE linkData (
  id BIGINT NOT NULL AUTO_INCREMENT,
  src_id INT NOT NULL,
  seq_no INT NOT NULL,
  exp_id VARCHAR(45) NOT NULL,
  exp_run_nbr INT NOT NULL,
  src_x FLOAT NULL,
  src_y FLOAT NULL,
  src_z FLOAT NULL,
  src_timestamp VARCHAR(50) NULL,
  rcv_id INT NULL,
  rcv_x FLOAT NULL, 
  rcv_y FLOAT NULL,
  rcv_z FLOAT NULL,
  rcv_timestamp VARCHAR(50) NULL,
  rtxcount INT NULL,
  lqi INT NULL,
  rssi INT NULL,
  noise INT NULL,
  snr FLOAT NULL,
  humidity FLOAT NULL,
  temperature FLOAT NULL,
  voltage FLOAT NULL,
  light1 FLOAT NULL,
  light2 FLOAT NULL,
  pressure FLOAT NULL,
  PRIMARY KEY(id, src_id, rcv_id, seq_no, exp_id, exp_run_nbr),
  FOREIGN KEY(exp_id, exp_run_nbr) REFERENCES experiment (exp_id, exp_run_nbr)
);

CREATE TABLE SenderSide (
  ids BIGINT NOT NULL AUTO_INCREMENT,
  src_id INT NOT NULL,
  seq_no INT NOT NULL,
  exp_id VARCHAR(45) NOT NULL,
  exp_run_nbr INT NOT NULL,
  src_timestamp VARCHAR(50) NOT NULL,
  rcv_id INT NOT NULL,
  rtxcount INT NULL,
  ackted INT NULL,
  PRIMARY KEY(ids, src_id, rcv_id, seq_no, exp_id, exp_run_nbr,rtxcount),
  FOREIGN KEY(exp_id, exp_run_nbr) REFERENCES experiment (exp_id, exp_run_nbr)
);

